/* ================================================================================ */
/*   driver/aqm0802a.c                                                              */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"
#include "aqm0802a.h"


	enum {
		SLAVE_ADDRESS				=	0x3e						/* X[uAhX */
	} ;


static const uint8_t				m_initData[]={					/* f[^ */
										0x38,
										0x39,
										0x14,
										0x70,
										0x56,
										0x6c,
										0x38,
										0x0c,
										0x01
									} ;


static __FAR uint8_t				m_buff[2] ;						/* ƃobt@ */


/* ------------------------------------------------------------------------------------------------ */
/*   public                                                                                         */

/* -------------------------------------------------------------------------------- */
/*                                                                            */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: E_OK                                                                      */
/*        I2C_E_BUS                                                                 */
/*        I2C_E_NACK                                                                */
/* -------------------------------------------------------------------------------- */
int8_t aqm0802a_init( void )
{
	int8_t		result ;
	uint8_t		index ;

	/* 40ms ҂ */
	AQM0802A_WAIT40ms() ;

	/*  */
	for(index=0; index<sizeof( m_initData ); index++ ) {
		result = aqm0802a_writeInstCode( m_initData[index] ) ;
		if( result ) {
			return result ;
		}

		if( index == 5 ) {
			AQM0802A_WAIT200ms() ;
		}
	}

	/* ҂ */
	AQM0802A_WAIT1_08ms() ;

	return E_OK ;
}


/* -------------------------------------------------------------------------------- */
/*   CXgNVR[h                                             */
/*                                                                                  */
/*   IN : instCode = CXgNVR[h                                       */
/*   OUT: E_OK                                                                      */
/*        I2C_E_BUS                                                                 */
/*        I2C_E_NACK                                                                */
/* -------------------------------------------------------------------------------- */
int8_t aqm0802a_writeInstCode( uint16_t instCode )
{
	int8_t	result ;


	AQM0802A_LOCK() ;

	m_buff[0] = (uint8_t )(instCode >> 8) | 0x80 ;
	m_buff[1] = (uint8_t )(instCode >> 0) ;
	result    = AQM0802A_SEND(SLAVE_ADDRESS, &m_buff[0], 2) ;

	AQM0802A_UNLOCK() ;

	if( result ) {
		return result ;
	}

	if( instCode & 0x30fc ) {
		AQM0802A_WAIT26_3us() ;
	} else {
		AQM0802A_WAIT1_08ms() ;
	}

	return E_OK ;
}
