/* ================================================================================ */
/*   driver/aqm0802a.h                                                              */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __DRIVER__AQM0802A_H__INCLUDED__
#define __DRIVER__AQM0802A_H__INCLUDED__


#define aqm0802a_clearDisplay()						aqm0802a_writeInstCode( 0x8001 )
#define aqm0802a_returnHome()						aqm0802a_writeInstCode( 0x8002 )
#define aqm0802a_entryModeSet(i_d, s)				aqm0802a_writeInstCode( 0x8004 | ((i_d)<<1) | (s) )
#define aqm0802a_displayOnOff(d, c, b)				aqm0802a_writeInstCode( 0x8008 | ((d)<<2) | ((c)<<1) | (b) )
#define aqm0802a_functionSet(n, dh, is)				aqm0802a_writeInstCode( 0x8020 | ((n)<<3) | ((dh)<<2) | (is) )
#define aqm0802a_setDdramAddress( add )				aqm0802a_writeInstCode( 0x8080 | (add) )
#define aqm0802a_writeDataToRam( data )				aqm0802a_writeInstCode( 0xc000 | (data) )

/* Instruction table 0iIS=0j */
#define aqm0802a_cursorOrDisplayShift(s_c, r_l)		aqm0802a_writeInstCode( 0x8010 | ((s_c)<<3) | ((r_l)<<2) )
#define aqm0802a_setCgram( ac )						aqm0802a_writeInstCode( 0x8040 | (ac) )

/* Instruction table 1iIS=1j */
#define aqm0802a_internalOscFrequency(bs, s)		aqm0802a_writeInstCode( 0x8010 | ((bs)<<3) | (f) )
#define aqm0802a_setIconAddress( ac )				aqm0802a_writeInstCode( 0x8040 | (ac) )
#define aqm0802a_powerIconControlContrastSet(ion, bon, c)	aqm0802a_writeInstCode( 0x8050 | ((ion)<<3) | ((bon)<<3) | (c) )
#define aqm0802a_followerControl(fon, rab)			aqm0802a_writeInstCode( 0x8060 | ((fon)<<3) | (rab) )
#define aqm0802a_contrastSet( c )					aqm0802a_writeInstCode( 0x8070 | (c) )


extern int8_t aqm0802a_init( void ) ;
extern int8_t aqm0802a_writeInstCode( uint16_t instCode ) ;


#endif/*__DRIVER__AQM0802A_H__INCLUDED__*/
