/* ================================================================================ */
/*   driver/ili9325.c                                                               */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"
#include "ili9325.h"


/* -------------------------------------------------------------------------------- */
/*                                                                            */
/*                                                                                  */
/*   IN : p_reg = WX^ݒf[^                                                */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void ili9325_init( const ILI9325REG __CODE *p_reg )
{
	/*  */
	ILI9325_CS_HI() ;
	ILI9325_RS_HI() ;
	ILI9325_WR_HI() ;

	/* Zbg */
	ILI9325_RST_HI() ;
	ILI9325_WAITms( 1 ) ;
	ILI9325_RST_LO() ;
	ILI9325_WAITms( 10 ) ;
	ILI9325_RST_HI() ;
	ILI9325_WAITms( 50 ) ;

	do {
		if( p_reg->index != ILI9325_WMS ) {
			ili9325_writeReg(p_reg->index, p_reg->value) ;
		} else {
			ILI9325_WAITms( p_reg->value ) ;
		}
		p_reg++ ;
	} while( p_reg->index ) ;
}


#ifdef  ILI9325_8BIT
/* -------------------------------------------------------------------------------- */
/*   CfbNX                                                           */
/*                                                                                  */
/*   IN : index = CfbNX                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void ili9325_writeIndex( uint8_t index )
{
	ILI9325_CS_LO() ;
	ILI9325_RS_LO() ;

	ILI9325_DB( 0x00 ) ;
	ILI9325_WR_LO() ;
	ILI9325_WR_HI() ;

	ILI9325_DB( index ) ;
	ILI9325_WR_LO() ;
	ILI9325_WR_HI() ;

	ILI9325_RS_HI() ;
	ILI9325_CS_HI() ;
}


/* -------------------------------------------------------------------------------- */
/*   f[^                                                                 */
/*                                                                                  */
/*   IN : data = f[^                                                             */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void ili9325_writeData( uint16_t data )
{
	ILI9325_CS_LO() ;

	ILI9325_DB( (uint8_t )(data>>8) ) ;
	ILI9325_WR_LO() ;
	ILI9325_WR_HI() ;

	ILI9325_DB( (uint8_t )(data>>0) ) ;
	ILI9325_WR_LO() ;
	ILI9325_WR_HI() ;

	ILI9325_CS_HI() ;
}


/* -------------------------------------------------------------------------------- */
/*   WX^                                                               */
/*                                                                                  */
/*   IN : index = CfbNX                                                      */
/*        data  = f[^                                                            */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void ili9325_writeReg(uint8_t index, uint16_t data)
{
	ILI9325_CS_LO() ;

	/* CfbNX */
	ILI9325_RS_LO() ;
	ILI9325_DB( 0x00 ) ;
	ILI9325_WR_LO() ;
	ILI9325_WR_HI() ;

	ILI9325_DB( index ) ;
	ILI9325_WR_LO() ;
	ILI9325_WR_HI() ;
	ILI9325_RS_HI() ;

	/* f[^ */
	ILI9325_DB( data >> 8 ) ;
	ILI9325_WR_LO() ;
	ILI9325_WR_HI() ;

	ILI9325_DB( data >> 0 ) ;
	ILI9325_WR_LO() ;
	ILI9325_WR_HI() ;

	ILI9325_CS_HI() ;
}
#endif/*ILI9325_8BIT*/
