/* ================================================================================ */
/*   driver/lm024c9325.h                                                            */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __DRIVER__LM024C9325_H__INCLUDED__
#define __DRIVER__LM024C9325_H__INCLUDED__


#include "ili9325.h"


	enum {
		LM024C9325_SCREEN_WIDTH		=	240,
		LM024C9325_SCREEN_HEIGHT	=	320
	} ;


extern const ILI9325REG				g_lm024c9325Reg[] ;


#define lm024c9325_init()						ili9325_init( &g_lm024c9325Reg[0] )
#define lm024c9325_setAddressH( pos )			ili9325_writeReg(ILI9325_R20, pos)
#define lm024c9325_setAddressV( pos )			ili9325_writeReg(ILI9325_R21, pos)
#define lm024c9325_setWindowArea(x, y, w, h)	\
{												\
	ili9325_writeReg(ILI9325_R50, (x)) ;		\
	ili9325_writeReg(ILI9325_R51, (x)+(w)-1) ;	\
	ili9325_writeReg(ILI9325_R52, (y)) ;		\
	ili9325_writeReg(ILI9325_R53, (y)+(h)-1) ;	\
}
#define lm024c9325_beginWriteData()				ili9325_writeIndex( ILI9325_R22 )
#define lm024c9325_writeData( data )			ili9325_writeData( data )
#define lm024c9325_vscroll( pos )				ili9325_writeReg(ILI9325_R6A, pos)


#endif/*__DRIVER__LM024C9325_H__INCLUDED__*/
