/* ================================================================================ */
/*   driver/mpl115a1.h                                                              */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __DRIVER__MPL115A1_H__INCLUDED__
#define __DRIVER__MPL115A1_H__INCLUDED__

	/* A/D ϊl */
	typedef struct {
		uint16_t					padc ;							/* C A/D ϊl */
		uint16_t					tadc ;							/* x A/D ϊl */
	} MPL115A1ADC ;


#define mpl115a1_init				MPL115A1_CSHI
#define mpl115a1_select()			MPL115A1_MODE( SPI_MODE0 )

extern void    mpl115a1_readCoefficient( void ) ;
extern void    mpl115a1_read( MPL115A1ADC MPL115A1_SEG_ADC *p_adc ) ;
extern int16_t mpl115a1_getPressure( const MPL115A1ADC MPL115A1_SEG_ADC *p_adc ) ;
extern int16_t mpl115a1_getTemperature( uint16_t tadc ) ;


#endif/*__DRIVER__MPL115A1_H__INCLUDED__*/
