/* ================================================================================ */
/*   driver/sc1602bs.c                                                              */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"
#include "sc1602bs.h"


/* -------------------------------------------------------------------------------- */
/*                                                                            */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void sc1602bs_init( void )
{
	/*  */
	SC1602BS_E_LO() ;
	SC1602BS_RS_LO() ;
	SC1602BS_DB( 0x30 ) ;

	/* 15ms ҂ */
	SC1602BS_WAIT15ms() ;

	/* 0x3-  */
	SC1602BS_E_HI() ;
	SC1602BS_WAIT220ns() ;
	SC1602BS_E_LO() ;
	SC1602BS_WAIT220ns() ;

	/* 4.1ms ҂ */
	SC1602BS_WAIT4_1ms() ;

	/* 0x3-  */
	SC1602BS_E_HI() ;
	SC1602BS_WAIT220ns() ;
	SC1602BS_E_LO() ;
	SC1602BS_WAIT220ns() ;

	/* 100us ҂ */
	SC1602BS_WAIT100us() ;

	/* 0x3-  */
	SC1602BS_E_HI() ;
	SC1602BS_WAIT220ns() ;
	SC1602BS_E_LO() ;
	SC1602BS_WAIT220ns() ;

	/* 40us ҂ */
	SC1602BS_WAIT40us() ;

	/* 0x2-  */
	SC1602BS_E_HI() ;
	SC1602BS_WAIT40ns() ;
	SC1602BS_DB( 0x20 ) ;
	SC1602BS_WAIT220ns() ;
	SC1602BS_E_LO() ;
	SC1602BS_WAIT220ns() ;

	/* 40us ҂ */
	SC1602BS_WAIT40us() ;

	/* \It */
	sc1602bs_displayOnOffControl(0, 0, 0) ;

	/* \NA */
	sc1602bs_clearDisplay() ;
}


/* -------------------------------------------------------------------------------- */
/*   f[^                                                                 */
/*                                                                                  */
/*   IN : instCode = CXgNVR[h                                       */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void sc1602bs_writeInstCode( uint16_t instCode )
{
	SC1602BS_LOCK() ;

#if    (SC1602BS_MODE == 4)
	if( instCode & SC1602BS_RS ) {
		SC1602BS_RS_HI() ;
	} else {
		SC1602BS_RS_LO() ;
	}
	SC1602BS_WAIT40ns() ;

	/* ʂSrbg */
	SC1602BS_E_HI() ;
	SC1602BS_WAIT40us() ;
	SC1602BS_DB( (uint8_t )instCode ) ;
	SC1602BS_WAIT220ns() ;
	SC1602BS_E_LO() ;
	SC1602BS_WAIT220ns() ;

	/* ʂSrbg */
	SC1602BS_E_HI() ;
	SC1602BS_WAIT40us() ;
	SC1602BS_DB( (uint8_t )instCode << 4 ) ;
	SC1602BS_WAIT220ns() ;
	SC1602BS_E_LO() ;
	SC1602BS_WAIT220ns() ;
#else

#endif/*SC1602BS_MODE*/

	SC1602BS_UNLOCK() ;

	if( instCode & 0x03fc ) {
		SC1602BS_WAIT40us() ;
	} else {
		SC1602BS_WAIT1_6ms() ;
	}
}
