/* ================================================================================ */
/*   driver/sc1602bs.h                                                              */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __DRIVER__SC1602BS_H__INCLUDED__
#define __DRIVER__SC1602BS_H__INCLUDED__


	enum {
		SC1602BS_E_					=	10,
		SC1602BS_RS_				=	9,
		SC1602BS_RW_				=	8,
		SC1602BS_DB7_				=	7,
		SC1602BS_DB6_				=	6,
		SC1602BS_DB5_				=	5,
		SC1602BS_DB4_				=	4,
		SC1602BS_DB3_				=	3,
		SC1602BS_DB2_				=	2,
		SC1602BS_DB1_				=	1,
		SC1602BS_DB0_				=	0,
		SC1602BS_E					=	1 << SC1602BS_E_,
		SC1602BS_RS					=	1 << SC1602BS_RS_,
		SC1602BS_RW					=	1 << SC1602BS_RW_,
		SC1602BS_DB7				=	1 << SC1602BS_DB7_,
		SC1602BS_DB6				=	1 << SC1602BS_DB6_,
		SC1602BS_DB5				=	1 << SC1602BS_DB5_,
		SC1602BS_DB4				=	1 << SC1602BS_DB4_,
		SC1602BS_DB3				=	1 << SC1602BS_DB3_,
		SC1602BS_DB2				=	1 << SC1602BS_DB2_,
		SC1602BS_DB1				=	1 << SC1602BS_DB1_,
		SC1602BS_DB0				=	1 << SC1602BS_DB0_
	} ;


#define sc1602bs_clearDisplay()						sc1602bs_writeInstCode( 0x0001 )
#define sc1602bs_cursorAtHome()						sc1602bs_writeInstCode( 0x0002 )
#define sc1602bs_entryModeSet(i_d, s)				sc1602bs_writeInstCode( 0x0004 | ((i_d)<<1) | (s) )
#define sc1602bs_displayOnOffControl(d, c, b)		sc1602bs_writeInstCode( 0x0008 | ((d)<<2) | ((c)<<1) | (b) )
#define sc1602bs_cursorDisplayShift(s_c, r_l)		sc1602bs_writeInstCode( 0x0010 | ((s_c)<<3) | ((r_l)<<2) )
#define sc1602bs_functionSet(n, f)					sc1602bs_writeInstCode( 0x0020 | ((SC1602BS_MODE/8)<<4) | ((n)<<3) | ((f)<<2) )
#define sc1602bs_cgramAddressSet( acg )				sc1602bs_writeInstCode( 0x0040 | (acg) )
#define sc1602bs_ddramAddressSet( add )				sc1602bs_writeInstCode( 0x0080 | (add) )
#define sc1602bs_cgramDdramDataWrite( data )		sc1602bs_writeInstCode( SC1602BS_RS | (data) )


extern void sc1602bs_init( void ) ;
extern void sc1602bs_writeInstCode( uint16_t instCode ) ;


#endif/*__DRIVER__SC1602BS_H__INCLUDED__*/
