/* ================================================================================ */
/*   driver/spi.c                                                                   */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"


static uint8_t						m_mode ;						/* SPI [h */


/* -------------------------------------------------------------------------------- */
/*                                                                            */
/*                                                                                  */
/*   IN : mode = SPI [h                                                         */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void spi_init( uint8_t mode )
{
	m_mode = mode ;

	SPI_SCLK( mode / 2 ) ;
}


/* -------------------------------------------------------------------------------- */
/*   Wrbg]                                                                   */
/*                                                                                  */
/*   IN : sendData = Mf[^                                                     */
/*   OUT: Mf[^                                                                */
/* -------------------------------------------------------------------------------- */
uint8_t spi_xfer8( uint8_t sendData )
{
	BOOL		sclk ;
	uint8_t		count, result ;


	count  = 8 ;
	result = 0 ;
	sclk   = m_mode / 2 ;

	if( !(m_mode&1) ) {		/* [hOEQ */

		do {
			SPI_MOSI( sendData >> 7 ) ;
			sendData <<= 1 ;

			result = (result << 1) | SPI_MISO() ;

			sclk ^= 1 ;
			SPI_SCLK( sclk ) ;

			SPI_WAIT0() ;

			sclk ^= 1 ;
			SPI_SCLK( sclk ) ;

			SPI_WAIT1() ;
		} while( --count ) ;

	} else {				/* [hPER */

		do {
			sclk ^= 1 ;
			SPI_SCLK( sclk ) ;

			SPI_MOSI( sendData >> 7 ) ;
			sendData <<= 1 ;

			SPI_WAIT1() ;

			sclk ^= 1 ;
			SPI_SCLK( sclk ) ;

			result = (result << 1) | SPI_MISO() ;

			SPI_WAIT0() ;
		} while( --count ) ;

	}

	return result ;
}
