/* ================================================================================ */
/*   8052/config.h                                                                  */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __8052__CONFIG_H__INCLUDED__
#define __8052__CONFIG_H__INCLUDED__


#include "depend.h"

/* gphCo[` */
#define CONFIG_UART
//#define CONFIG_SPI
#define CONFIG_SC1602BS
//#define CONFIG_ILI9325
//#define CONFIG_MCP3002
//#define CONFIG_MPL115A1
//#define CONFIG_SDC


#include "uart.h"
#include "spi.h"
#include "sdc.h"


/* ---------------------------------------------------------------- */
/*   UART                                                           */
/* ---------------------------------------------------------------- */
#define UART_TX_SEMID				1								/* MpZ}tH ID ԍ    */
#define UART_RX_SEMID				2								/* MpZ}tH ID ԍ    */
#define UART_SENDBUFF_SIZE			8								/* Mobt@TCYi2^nj */
#define UART_RECVBUFF_SIZE			8								/* Mobt@TCYi2^nj */
#define UART_COUNTER				0xf3							/* JE^i4800bpsj       */


/* ---------------------------------------------------------------- */
/*   SPI                                                            */
/* ---------------------------------------------------------------- */
#define SPI_SCLK					"P3_0"							/* SCLK pin */
#define SPI_MOSI					"P3_1"							/* MOSI pin */
#define SPI_MISO					"P3_3"							/* MISO pin */


/* ---------------------------------------------------------------- */
/*   SC1602BS                                                       */
/* ---------------------------------------------------------------- */
#define SC1602BS_LOCK()												/* bN                 */
#define SC1602BS_UNLOCK()											/* bN             */
#define SC1602BS_MODE				4								/* C^tF[Xrbg */
#define SC1602BS_E_LO()				P1_7 = 0						/*  E pin Low             */
#define SC1602BS_E_HI()				P1_7 = 1						/*  E pin High            */
#define SC1602BS_RS_LO()			P1_6 = 0						/* RS pin Low             */
#define SC1602BS_RS_HI()			P1_6 = 1						/* RS pin High            */
																	/* DB pin                 */
#define SC1602BS_DB( n )			\
{									\
	P3_5 = ((n) >> 7) & 1 ;			\
	P3_4 = ((n) >> 6) & 1 ;			\
	P3_3 = ((n) >> 5) & 1 ;			\
	P3_2 = ((n) >> 4) & 1 ;			\
}

#define SC1602BS_WAIT40ns()											/*  40ns ȏ҂         */
#define SC1602BS_WAIT220ns()										/* 220ns ȏ҂         */
#define SC1602BS_WAIT40us()			wait10us( 4 )					/*  40us ȏ҂         */
#define SC1602BS_WAIT100us()		wait10us( 10 )					/* 100us ȏ҂         */
#define SC1602BS_WAIT1_6ms()		dly_tsk( 2 )					/* 1.6ms ȏ҂         */
#define SC1602BS_WAIT4_1ms()		dly_tsk( 5 )					/* 4.1ms ȏ҂         */
#define SC1602BS_WAIT15ms()			dly_tsk( 15 )					/*  15ms ȏ҂         */


/* ---------------------------------------------------------------- */
/*   MCP3002                                                        */
/* ---------------------------------------------------------------- */
#define MCP3002_LOCK()												/* bN         */
#define MCP3002_UNLOCK()											/* bN     */
#define MCP3002_MODE( mode )		spi_mode( mode )				/* [hI */
#define MCP3002_XFER( value )		spi_xfer8( value )				/* ]       */
#define MCP3002_CS_LO()				P1_2 = 0						/* CS pin Low     */
#define MCP3002_CS_HI()				P1_2 = 1						/* CS pin High    */


/* ---------------------------------------------------------------- */
/*   MPL115A1                                                       */
/* ---------------------------------------------------------------- */
#define MPL115A1_LOCK()												/* bN                   */
#define MPL115A1_UNLOCK()											/* bN               */
#define MPL115A1_ADC_COUNT			16								/* A/D ϊ             */
#define MPL115A1_MODE( mode )		spi_mode( mode )				/* [hI           */
#define MPL115A1_XFER( value )		spi_xfer8( value )				/* ]                 */
#define MPL115A1_CS_LO()			P1_6 = 0						/* CS pin Low               */
#define MPL115A1_CS_HI()			P1_6 = 1						/* CS pin High              */
#define MPL115A1_WAIT3ms()			dly_tsk( 3 )					/* 3ms ȏ҂             */
#define MPL115A1_WAIT5ms()			dly_tsk( 5 )					/* 5ms ȏ҂             */
#define MPL115A1_SEG_ADC			__NEARI							/* A/D ϊlzuZOg */


/* ---------------------------------------------------------------- */
/*   SDC                                                            */
/* ---------------------------------------------------------------- */
#define SDC_LOCK()													/* bN         */
#define SDC_UNLOCK()												/* bN     */
#define SDC_MODE( mode )			spi_mode( mode )				/* [hI */
#define SDC_XFER( value )			spi_xfer8( value )				/* ]       */
#define SDC_CS_LO()					P1_4 = 0						/* CS pin Low     */
#define SDC_CS_HI()					P1_4 = 1						/* CS pin High    */


/* ---------------------------------------------------------------- */
/*   RSFAT                                                          */
/* ---------------------------------------------------------------- */
#define RSFAT_LOCK()												/* bN       */
#define RSFAT_UNLOCK()												/* bN   */
#define RSFAT_INIT()				sdc_reset()						/*    */
																	/* ǂݍݏ */
#define RSFAT_READ(sector, p_buff, count)	sdc_read(sector, p_buff, count)
#define RSFAT_WORK					__FAR							/* Ɨ̈     */


/* ---------------------------------------------------------------- */
/*   eXgAv                                                   */
/* ---------------------------------------------------------------- */
#define APP_LED0( value )			P1_0 = (value)
#define APP_LED1( value )			P1_1 = (value)
#define APP_LED2( value )			P1_2 = (value)
#define APP_LED3( value )			P1_3 = (value)

#define getchar()					uart_read()
#define putchar( c )				uart_write( c )


#endif/*__8052__CONFIG_H__INCLUDED__*/
