/* ================================================================================ */
/*   8052/spi.c                                                                     */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"


static __NEAR uint8_t				m_mode ;						/* SPI [h */


/* -------------------------------------------------------------------------------- */
/*   [hݒ                                                                     */
/*                                                                                  */
/*   IN : mode = [h                                                             */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void spi_mode( uint8_t mode ) __naked
{
	mode = mode ;

	__asm__(
	"P0_0		=	0x80+0								\n"
	"P0_1		=	0x80+1								\n"
	"P0_2		=	0x80+2								\n"
	"P0_3		=	0x80+3								\n"
	"P0_4		=	0x80+4								\n"
	"P0_5		=	0x80+5								\n"
	"P0_6		=	0x80+6								\n"
	"P0_7		=	0x80+7								\n"
	"P1_0		=	0x90+0								\n"
	"P1_1		=	0x90+1								\n"
	"P1_2		=	0x90+2								\n"
	"P1_3		=	0x90+3								\n"
	"P1_4		=	0x90+4								\n"
	"P1_5		=	0x90+5								\n"
	"P1_6		=	0x90+6								\n"
	"P1_7		=	0x90+7								\n"
	"P3_0		=	0xb0+0								\n"
	"P3_1		=	0xb0+1								\n"
	"P3_2		=	0xb0+2								\n"
	"P3_3		=	0xb0+3								\n"
	"P3_4		=	0xb0+4								\n"
	"P3_5		=	0xb0+5								\n"
	"SCLK		=	" SPI_SCLK                         "\n"
	"MOSI		=	" SPI_MOSI                         "\n"
	"MISO		=	" SPI_MISO                         "\n"
	"													\n"
	"													\n"
	"	MOV		A, DPL									\n"
	"	MOV		_m_mode, A								\n"
	"													\n"
	"	JB		ACC.3, _spi_mode_180					\n"
	"													\n"
	"_spi_mode_100:										\n"
	"	CLR		SCLK									\n"
	"	SETB	MOSI									\n"
	"	RET												\n"
	"													\n"
	"_spi_mode_180:										\n"
	"	SETB	SCLK									\n"
	"	SETB	MOSI									\n"
	"	RET												\n"
	) ;
}

/* -------------------------------------------------------------------------------- */
/*   Wrbg]                                                                   */
/*                                                                                  */
/*   IN : sendData = Mf[^                                                     */
/*   OUT: Mf[^                                                                */
/* -------------------------------------------------------------------------------- */
uint8_t spi_xfer8( uint8_t sendData ) __naked
{
	sendData = sendData ;

	__asm__(
	"	MOV		R0, DPL									\n"
	"	MOV		R1, #8									\n"
	"	MOV		DPTR, #spi_xfer_jmptbl					\n"
	"	MOV		A, _m_mode								\n"
	"	JMP		@A+DPTR									\n"
	"													\n"
	"spi_xfer_jmptbl:									\n"
	"	CLR		SCLK					; [h 0		\n"
	"	SJMP	spi_xfer_mode02							\n"
	"	CLR		SCLK					; [h 1		\n"
	"	SJMP	spi_xfer_mode13							\n"
	"	SETB	SCLK					; [h 2		\n"
	"	SJMP	spi_xfer_mode02							\n"
	"	SETB	SCLK					; [h 3		\n"
	"	SJMP	spi_xfer_mode13							\n"
	"													\n"
	"; ------------------------------------------------ \n"
	";   [h 0/2                                     \n"
	"; ------------------------------------------------ \n"
	"spi_xfer_mode02:									\n"
	"	MOV		A, R0									\n"
	"	RLC		A										\n"
	"	SJMP	spi_xfer_mode02_140						\n"
	"													\n"
	"spi_xfer_mode02_100:								\n"
	"	CPL		SCLK					; 2				\n"
	"spi_xfer_mode02_140:								\n"
	"	MOV		MOSI, C					; 2				\n"
	"	MOV		C, MISO					; 2				\n"		/* SCLK XVOɓǂݍővȂ͂ */
	"	CPL		SCLK					; 2				\n"
	"	RLC		A						; 1				\n"
	"	DJNZ	R1, spi_xfer_mode02_100	; 3				\n"
	"													\n"
	"	CPL		SCLK									\n"
	"	MOV		DPL, A									\n"
	"	RET												\n"
	"													\n"
	"; ------------------------------------------------ \n"
	";   [h 1/3                                     \n"
	"; ------------------------------------------------ \n"
	"spi_xfer_mode13:									\n"
	"	MOV		A, R0									\n"
	"	RLC		A										\n"
	"spi_xfer_mode13_100:								\n"
	"	CPL		SCLK					; 2				\n"
	"	MOV		MOSI, C					; 2				\n"
	"	MOV		C, MISO					; 2				\n"		/* SCLK XVOɓǂݍővȂ͂ */
	"	CPL		SCLK					; 2				\n"
	"	RLC		A						; 1				\n"
	"	DJNZ	R1, spi_xfer_mode13_100	; 3				\n"
	"	MOV		DPL, A									\n"
	"	RET												\n"
	) ;
}
