/* ================================================================================ */
/*   ezusb/depend.c                                                                 */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"
#include "mcp3002.h"
#include "mpl115a1.h"


/* -------------------------------------------------------------------------------- */
/*                                                                            */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void rtos_init( void )
{
	/* WX^ */
	MPAGE = 0x7f ;
	CKCON = CKCON_T2M | CKCON_T1M | CKCON_T0M ;

#ifdef  CONFIG_UART
	PORTCCFG = PORTCCFG_TXD0 | PORTCCFG_RXD0 ;
#endif/*CONFIG_UART*/

	/* |[gݒ */
#if     (PORTA_DIR != 0)
	OEA = PORTA_DIR ;
#endif/*(PORTA_DIR != 0)*/

#if     (PORTB_DIR != 0)
	OEB = PORTB_DIR ;
#endif/*(PORTB_DIR != 0)*/

#if     (PORTC_DIR != 0)
	OEC = PORTC_DIR ;
#endif/*(PORTC_DIR != 0)*/

	/* hCo[ */
#ifdef  CONFIG_UART
	uart_init() ;
#endif/*CONFIG_UART*/

#ifdef  CONFIG_I2C
	i2c_init() ;
#endif/*CONFIG_UART*/

#ifdef  CONFIG_SDC
	sdc_init() ;
#endif/*CONFIG_SDC*/

#ifdef  CONFIG_MCP3002
	mcp3002_init() ;
#endif/*CONFIG_MCP3002*/

#ifdef  CONFIG_MPL115A1
	mpl115a1_init() ;
#endif/*CONFIG_MPL115A1*/
}


/* -------------------------------------------------------------------------------- */
/*   10us ҂                                                                      */
/*                                                                                  */
/*   IN : count = ҂                                                          */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void wait10us( uint16_t count ) __naked
{
	count = count ;

	__asm__(
	"	MOV		R0, DPH							\n"
	"	INC		R0								\n"
	"wait10us_100:								\n"
	"	; 10us = 60 = 2 + (18 * 3) + 4			\n"
	"	MOV		R1, #18				; 2 cycle	\n"
	"wait10us_180:								\n"
	"	DJNZ	R1, wait10us_180	; 3 cycle	\n"
	"	DJNZ	DPL, wait10us_100	; 4 cycle	\n"
	"	DJNZ	R0, wait10us_100				\n"
	"	RET										\n"
	) ;
}
