; ================================================================================ 
;   ezusb/kernel_cfg.asm                                                           
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

; ------------------------------------------------ 
;   J[lݒ                                   
; ------------------------------------------------ 
KERNEL_CFG_STKSZ	=	24				; J[l̃X^bNTCY
KERNEL_CFG_SIG_TIM	=	6000				; ^CeBbN̋ԁi1ms = 24000000 / 4 / 1000j
KERNEL_CFG_TSK_REG	=	8				; ^XÑWX^ۑ
KERNEL_CFG_TSK_PRI	=	4				; ^XNDx̍ől


; ------------------------------------------------ 
;   J[lRtBO}N                       
; ------------------------------------------------ 
DPL1			=	0x84
DPH1			=	0x85
DPS			=	0x86

	.macro	KERNEL_CFG_ISR_ENTER				; 荞݃T[rX[`
	PUSH	DPS
	MOV	DPS, #0x00
	.endm

	.macro	KERNEL_CFG_ISR_LEAVE				; 荞݃T[rX[`o
	POP	DPS
	.endm

	.macro	KERNEL_CFG_DSP_ENTER				; fBXpb`
	MOV	A, DPL1
	MOVX	@DPTR, A
	INC	DPTR
	MOV	A, DPH1
	MOVX	@DPTR, A
	INC	DPTR
	.endm

	.macro	KERNEL_CFG_DSP_LEAVE				; fBXpb`o
	MOVX	A, @DPTR
	MOV	DPL1, A
	INC	DPTR
	MOVX	A, @DPTR
	MOV	DPH1, A
	INC	DPTR
	.endm



; ------------------------------------------------ 
;   ^XN                                         
; ------------------------------------------------ 
CRE_TSK		0, _idle_tsk, KERNEL_CFG_TSK_PRI, 32		; ACh^XN
CRE_TSK		1, _main_tsk, 1,                  64		; C^XN
CRE_TSK		2, _sub_tsk,  2,                  64		; Tu^XN
CRE_TSK		3, _usb_tsk,  3,                  64		; USB ^XN


; ------------------------------------------------ 
;   Z}tH                                       
; ------------------------------------------------ 
CRE_SEM		1, 8, 8						; VAM
CRE_SEM		2, 0, 8						; VAM
CRE_SEM		3, 0, 1						; I2C 荞
CRE_SEM		4, 0, 1						; USB SETUP f[^荞
CRE_SEM		5, 1, 1						; eXgAvrp


; ------------------------------------------------ 
;   nh                                   
; ------------------------------------------------ 
CRE_CYC		1, TA_STA, _cychdr1,     100			; LED2 _
CRE_CYC		2, TA_STA, _cychdr2,    1000			; LED3 _
CRE_CYC		3, 0,      _usb_cychdr,  200			; USB eXgp


; ------------------------------------------------ 
;   荞݃nh                               
; ------------------------------------------------ 
DEF_INH		0x0003, 0					; INT0 O荞
DEF_INH		0x000b, 0					; ^C}O荞
DEF_INH		0x0013, 0					; INT1 O荞
DEF_INH		0x001b, 0					; ^C}P荞
DEF_INH		0x0023, 1, _uart_isr				; USART0 荞
DEF_INH		0x002b, 1					; ^C}Q荞݁iJ[l\j
DEF_INH		0x0033, 0					; W[荞
DEF_INH		0x003b, 0					; USART1 荞
DEF_INH		0x0043, 0, 0x0100				; USB 荞
DEF_INH		0x004b, 1, _i2c_isr				; I2C 荞
DEF_INH		0x0053, 0					; INT4 O荞
DEF_INH		0x005b, 0					; INT5 O荞
DEF_INH		0x0063, 0					; INT6 O荞
								; USB-Interrupt Jump Table
DEF_INH		0x0100, 1, _usb_isr_sudav			;   SETUP f[^L荞
DEF_INH		0x0104, 0, _usb_isr_sof				;   SOF 荞
DEF_INH		0x0108, 0, _usb_isr_sutok			;   SETUP f[^B荞
DEF_INH		0x010c, 0, _usb_isr_suspend			;   O[oTXyh荞
DEF_INH		0x0110, 0, _usb_isr_usbres			;   USB Zbg荞
DEF_INH		0x0114, 0					;   2122/2126 ̂
DEF_INH		0x0118, 0, _usb_isr_ep0in			;   IN  Gh|Cg #0 荞
DEF_INH		0x011c, 0, _usb_isr_ep0out			;   OUT Gh|Cg #0 荞
DEF_INH		0x0120, 0, _usb_isr_ep1in			;   IN  Gh|Cg #1 荞
DEF_INH		0x0124, 0, _usb_isr_ep1out			;   OUT Gh|Cg #1 荞
DEF_INH		0x0128, 0, _usb_isr_ep2in			;   IN  Gh|Cg #2 荞
DEF_INH		0x012c, 0, _usb_isr_ep2out			;   OUT Gh|Cg #2 荞
DEF_INH		0x0130, 0, _usb_isr_ep3in			;   IN  Gh|Cg #3 荞
DEF_INH		0x0134, 0, _usb_isr_ep3out			;   OUT Gh|Cg #3 荞
DEF_INH		0x0138, 0, _usb_isr_ep4in			;   IN  Gh|Cg #4 荞
DEF_INH		0x013c, 0, _usb_isr_ep4out			;   OUT Gh|Cg #4 荞
DEF_INH		0x0140, 0, _usb_isr_ep5in			;   IN  Gh|Cg #5 荞
DEF_INH		0x0144, 0, _usb_isr_ep5out			;   OUT Gh|Cg #5 荞
DEF_INH		0x0148, 0, _usb_isr_ep6in			;   IN  Gh|Cg #6 荞
DEF_INH		0x014c, 0, _usb_isr_ep6out			;   OUT Gh|Cg #6 荞
DEF_INH		0x0150, 0, _usb_isr_ep7in			;   IN  Gh|Cg #7 荞
DEF_INH		0x0154, 0, _usb_isr_ep7out			;   OUT Gh|Cg #7 荞
