/* ================================================================================ */
/*   ezusb/regs.h                                                                   */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __EZUSB__REGS_H__INCLUDED__
#define __EZUSB__REGS_H__INCLUDED__

	/* PCON */
	enum {
		PCON_SMOD0					=	1 << 7,
		PCON_GF1					=	1 << 3,
		PCON_GF0					=	1 << 2,
		PCON_STOP					=	1 << 1,
		PCON_IDLE					=	1 << 0
	} ;

	/* CKCON */
	enum {
		CKCON_T2M					=	1 << 5,
		CKCON_T1M					=	1 << 4,
		CKCON_T0M					=	1 << 3,
		CKCON_MD2					=	1 << 2,
		CKCON_MD1					=	1 << 1,
		CKCON_MD0					=	1 << 0
	} ;

	/* SPC_FNC */
	enum {
		SPC_FNC_WRS					=	1 << 0
	} ;

	/* EXIF */
	enum {
		EXIF_IE5					=	1 << 7,
		EXIF_IE4					=	1 << 6,
		EXIF_I2CINT					=	1 << 5,
		EXIF_USBINT					=	1 << 4
	} ;


__sfr           __at (0x82)			DPL0 ;
__sfr           __at (0x83)			DPH0 ;
__sfr           __at (0x84)			DPL1 ;
__sfr           __at (0x85)			DPH1 ;
__sfr           __at (0x86)			DPS ;
__sfr           __at (0x8e)			CKCON ;
__sfr           __at (0x8f)			SPC_FNC ;
__sfr           __at (0x91)			EXIF ;
__sfr           __at (0x92)			MPAGE ;
__sfr           __at (0x98)			SCON0 ;
	__sbit      __at (0x98)			SM0_0 ;
	__sbit      __at (0x99)			SM1_0 ;
	__sbit      __at (0x9a)			SM2_0 ;
	__sbit      __at (0x9b)			REN_0 ;
	__sbit      __at (0x9c)			TB8_0 ;
	__sbit      __at (0x9d)			RB8_0 ;
	__sbit      __at (0x9e)			TI_0 ;
	__sbit      __at (0x9f)			RI_0 ;
__sfr           __at (0x99)			SBUF0 ;
__sfr           __at (0xc0)			SCON1 ;
	__sbit      __at (0xc0)			SM0_1 ;
	__sbit      __at (0xc1)			SM1_1 ;
	__sbit      __at (0xc2)			SM2_1 ;
	__sbit      __at (0xc3)			REN_1 ;
	__sbit      __at (0xc4)			TB8_1 ;
	__sbit      __at (0xc5)			RB8_1 ;
	__sbit      __at (0xc6)			TI_1 ;
	__sbit      __at (0xc7)			RI_1 ;
__sfr           __at (0xc1)			SBUF1 ;
//#__sfr           __at (0xd0)			PSW ;
	__sbit      __at (0xd1)			F1 ;
	__sbit      __at (0xd5)			F0 ;
__sfr           __at (0xd8)			EICON ;
	__sbit      __at (0xdb)			INT6 ;
	__sbit      __at (0xdc)			RESI ;
	__sbit      __at (0xdd)			ERESI ;
	__sbit      __at (0xdf)			SMOD1 ;
//#__sfr           __at (0xe0)			ACC ;
	__sbit      __at (0xe0)			ACC_0 ;
	__sbit      __at (0xe1)			ACC_1 ;
	__sbit      __at (0xe2)			ACC_2 ;
	__sbit      __at (0xe3)			ACC_3 ;
	__sbit      __at (0xe4)			ACC_4 ;
	__sbit      __at (0xe5)			ACC_5 ;
	__sbit      __at (0xe6)			ACC_6 ;
	__sbit      __at (0xe7)			ACC_7 ;
__sfr           __at (0xe8)			EIE ;
	__sbit      __at (0xe8)			EUSB ;
	__sbit      __at (0xe9)			EI2C ;
	__sbit      __at (0xea)			EX4 ;
	__sbit      __at (0xeb)			EX5 ;
	__sbit      __at (0xec)			EWDI ;
__sfr           __at (0xf8)			EIP ;
	__sbit      __at (0xf8)			PUSB ;
	__sbit      __at (0xf9)			PI2C ;
	__sbit      __at (0xfa)			PX4 ;
	__sbit      __at (0xfb)			PX5 ;
	__sbit      __at (0xfc)			PX6 ;

	/* CPUCS */
	enum {
		CPUCS_CLK24OE				=	1 << 1,
		CPUCS_8051RES				=	1 << 0
	} ;

	/* PORTACFG */
	enum {
		PORTACFG_RXD1OUT			=	1 << 7,
		PORTACFG_RXD0OUT			=	1 << 6,
		PORTACFG_FRD				=	1 << 5,
		PORTACFG_FWR				=	1 << 4,
		PORTACFG_CS					=	1 << 3,
		PORTACFG_OE					=	1 << 2,
		PORTACFG_T1OUT				=	1 << 1,
		PORTACFG_T0OUT				=	1 << 0
	} ;

	/* PORTBCFG */
	enum {
		PORTBCFG_T2OUT				=	1 << 7,
		PORTBCFG_INT8				=	1 << 6,
		PORTBCFG_INT5				=	1 << 5,
		PORTBCFG_INT4				=	1 << 4,
		PORTBCFG_TXD1				=	1 << 3,
		PORTBCFG_RXD1				=	1 << 2,
		PORTBCFG_T2EX				=	1 << 1,
		PORTBCFG_T2					=	1 << 0
	} ;

	/* PORTCCFG */
	enum {
		PORTCCFG_RD					=	1 << 7,
		PORTCCFG_WR					=	1 << 6,
		PORTCCFG_T1					=	1 << 5,
		PORTCCFG_T0					=	1 << 4,
		PORTCCFG_INT1				=	1 << 3,
		PORTCCFG_INT0				=	1 << 2,
		PORTCCFG_TXD0				=	1 << 1,
		PORTCCFG_RXD0				=	1 << 0
	} ;

	/* ISOERR */
	enum {
		ISOERR_ISO15ERR				=	1 << 7,
		ISOERR_ISO14ERR				=	1 << 6,
		ISOERR_ISO13ERR				=	1 << 5,
		ISOERR_ISO12ERR				=	1 << 4,
		ISOERR_ISO11ERR				=	1 << 3,
		ISOERR_ISO10ERR				=	1 << 2,
		ISOERR_ISO9ERR				=	1 << 1,
		ISOERR_ISO8ERR				=	1 << 0
	} ;

	/* ISOCTL */
	enum {
		ISOCTL_PPSTAT				=	1 << 3,
		ISOCTL_ISODISAB				=	1 << 0
	} ;

	/* ZBCOUT */
	enum {
		ZBCOUT_EP15					=	1 << 7,
		ZBCOUT_EP14					=	1 << 6,
		ZBCOUT_EP13					=	1 << 5,
		ZBCOUT_EP12					=	1 << 4,
		ZBCOUT_EP11					=	1 << 3,
		ZBCOUT_EP10					=	1 << 2,
		ZBCOUT_EP9					=	1 << 1,
		ZBCOUT_EP8					=	1 << 0
	} ;

	/* I2CS */
	enum {
		I2CS_START					=	1 << 7,
		I2CS_STOP					=	1 << 6,
		I2CS_LASTRD					=	1 << 5,
		I2CS_ID1					=	1 << 4,
		I2CS_ID0					=	1 << 3,
		I2CS_BERR					=	1 << 2,
		I2CS_ACK					=	1 << 1,
		I2CS_DONE					=	1 << 0
	} ;

	/* IVEC */
	enum {
		IVEC_IV4					=	1 << 6,
		IVEC_IV3					=	1 << 5,
		IVEC_IV2					=	1 << 4,
		IVEC_IV1					=	1 << 3,
		IVEC_IV0					=	1 << 2
	} ;

	/* IN07IRQ */
	enum {
		IN07IRQ_IN7IR				=	1 << 7,
		IN07IRQ_IN6IR				=	1 << 6,
		IN07IRQ_IN5IR				=	1 << 5,
		IN07IRQ_IN4IR				=	1 << 4,
		IN07IRQ_IN3IR				=	1 << 3,
		IN07IRQ_IN2IR				=	1 << 2,
		IN07IRQ_IN1IR				=	1 << 1,
		IN07IRQ_IN0IR				=	1 << 0
	} ;

	/* OUT07IRQ */
	enum {
		OUT07IRQ_OUT7IR				=	1 << 7,
		OUT07IRQ_OUT6IR				=	1 << 6,
		OUT07IRQ_OUT5IR				=	1 << 5,
		OUT07IRQ_OUT4IR				=	1 << 4,
		OUT07IRQ_OUT3IR				=	1 << 3,
		OUT07IRQ_OUT2IR				=	1 << 2,
		OUT07IRQ_OUT1IR				=	1 << 1,
		OUT07IRQ_OUT0IR				=	1 << 0
	} ;

	/* USBIRQ */
	enum {
		USBIRQ_URESIR				=	1 << 4,
		USBIRQ_SUSPIR				=	1 << 3,
		USBIRQ_SUTOKIR				=	1 << 2,
		USBIRQ_SOFIR				=	1 << 1,
		USBIRQ_SUDAVIR				=	1 << 0
	} ;

	/* IN07IEN */
	enum {
		IN07IEN_IN7IEN				=	1 << 7,
		IN07IEN_IN6IEN				=	1 << 6,
		IN07IEN_IN5IEN				=	1 << 5,
		IN07IEN_IN4IEN				=	1 << 4,
		IN07IEN_IN3IEN				=	1 << 3,
		IN07IEN_IN2IEN				=	1 << 2,
		IN07IEN_IN1IEN				=	1 << 1,
		IN07IEN_IN0IEN				=	1 << 0
	} ;

	/* OUT07IEN */
	enum {
		OUT07IEN_OUT7IEN			=	1 << 7,
		OUT07IEN_OUT6IEN			=	1 << 6,
		OUT07IEN_OUT5IEN			=	1 << 5,
		OUT07IEN_OUT4IEN			=	1 << 4,
		OUT07IEN_OUT3IEN			=	1 << 3,
		OUT07IEN_OUT2IEN			=	1 << 2,
		OUT07IEN_OUT1IEN			=	1 << 1,
		OUT07IEN_OUT0IEN			=	1 << 0
	} ;

	/* USBIEN */
	enum {
		USBIEN_URESIE				=	1 << 4,
		USBIEN_SUSPIE				=	1 << 3,
		USBIEN_SUTOKIE				=	1 << 2,
		USBIEN_SOFIE				=	1 << 1,
		USBIEN_SUDAVIE				=	1 << 0
	} ;

	/* USBBAV */
	enum {
		USBBAV_BREAK				=	1 << 3,
		USBBAV_BPPULSE				=	1 << 2,
		USBBAV_BPEN					=	1 << 1,
		USBBAV_AVEN					=	1 << 0
	} ;

	/* EP0CS */
	enum {
		EP0CS_OUTBSY				=	1 << 3,
		EP0CS_INBSY					=	1 << 2,
		EP0CS_HSNAK					=	1 << 1,
		EP0CS_EP0STALL				=	1 << 0
	} ;

	/* 0x7fb6-0x7fc2:INxCS: */
	enum {
		INxCS_INxBSY				=	1 << 1,
		INxCS_INxSTL				=	1 << 0
	} ;

	/* USBCS */
	enum {
		USBCS_WAKESRC				=	1 << 7,
		USBCS_DISCON				=	1 << 3,
		USBCS_DISCOE				=	1 << 2,
		USBCS_RENUM					=	1 << 1,
		USBCS_SIGRSUME				=	1 << 0
	} ;

	/* IN07VAL */
	enum {
		IN07VAL_IN7VAL				=	1 << 7,
		IN07VAL_IN6VAL				=	1 << 6,
		IN07VAL_IN5VAL				=	1 << 5,
		IN07VAL_IN4VAL				=	1 << 4,
		IN07VAL_IN3VAL				=	1 << 3,
		IN07VAL_IN2VAL				=	1 << 2,
		IN07VAL_IN1VAL				=	1 << 1,
		IN07VAL_IN0VAL				=	1 << 0
	} ;

	/* OUT07VAL */
	enum {
		OUT07VAL_OUT7VAL			=	1 << 7,
		OUT07VAL_OUT6VAL			=	1 << 6,
		OUT07VAL_OUT5VAL			=	1 << 5,
		OUT07VAL_OUT4VAL			=	1 << 4,
		OUT07VAL_OUT3VAL			=	1 << 3,
		OUT07VAL_OUT2VAL			=	1 << 2,
		OUT07VAL_OUT1VAL			=	1 << 1,
		OUT07VAL_OUT0VAL			=	1 << 0
	} ;

/* Endpoint 0-7 Data Buffers */
volatile __xdata __at (0x7b40) uint8_t		OUT7BUF[64] ;
volatile __xdata __at (0x7b80) uint8_t		IN7BUF[64] ;
volatile __xdata __at (0x7bc0) uint8_t		OUT6BUF[64] ;
volatile __xdata __at (0x7c00) uint8_t		IN6BUF[64] ;
volatile __xdata __at (0x7c40) uint8_t		OUT5BUF[64] ;
volatile __xdata __at (0x7c80) uint8_t		IN5BUF[64] ;
volatile __xdata __at (0x7cc0) uint8_t		OUT4BUF[64] ;
volatile __xdata __at (0x7d00) uint8_t		IN4BUF[64] ;
volatile __xdata __at (0x7d40) uint8_t		OUT3BUF[64] ;
volatile __xdata __at (0x7d80) uint8_t		IN3BUF[64] ;
volatile __xdata __at (0x7dc0) uint8_t		OUT2BUF[64] ;
volatile __xdata __at (0x7e00) uint8_t		IN2BUF[64] ;
volatile __xdata __at (0x7e40) uint8_t		OUT1BUF[64] ;
volatile __xdata __at (0x7e80) uint8_t		IN1BUF[64] ;
volatile __xdata __at (0x7ec0) uint8_t		OUT0BUF[64] ;
volatile __pdata __at (0x7f00) uint8_t		IN0BUF[64] ;

/* Isochronous Data */
volatile __pdata __at (0x7f60) uint8_t		OUT8DATA ;
volatile __pdata __at (0x7f61) uint8_t		OUT9DATA ;
volatile __pdata __at (0x7f62) uint8_t		OUT10DATA ;
volatile __pdata __at (0x7f63) uint8_t		OUT11DATA ;
volatile __pdata __at (0x7f64) uint8_t		OUT12DATA ;
volatile __pdata __at (0x7f65) uint8_t		OUT13DATA ;
volatile __pdata __at (0x7f66) uint8_t		OUT14DATA ;
volatile __pdata __at (0x7f67) uint8_t		OUT15DATA ;
volatile __pdata __at (0x7f68) uint8_t		IN8DATA ;
volatile __pdata __at (0x7f69) uint8_t		IN9DATA ;
volatile __pdata __at (0x7f6a) uint8_t		IN10DATA ;
volatile __pdata __at (0x7f6b) uint8_t		IN11DATA ;
volatile __pdata __at (0x7f6c) uint8_t		IN12DATA ;
volatile __pdata __at (0x7f6d) uint8_t		IN13DATA ;
volatile __pdata __at (0x7f6e) uint8_t		IN14DATA ;
volatile __pdata __at (0x7f6f) uint8_t		IN15DATA ;

/* Isochronous Byte Counts */
volatile __pdata __at (0x7f70) uint8_t		OUT8BCH ;
volatile __pdata __at (0x7f71) uint8_t		OUT8BCL ;
volatile __pdata __at (0x7f72) uint8_t		OUT9BCH ;
volatile __pdata __at (0x7f73) uint8_t		OUT9BCL ;
volatile __pdata __at (0x7f74) uint8_t		OUT10BCH ;
volatile __pdata __at (0x7f75) uint8_t		OUT10BCL ;
volatile __pdata __at (0x7f76) uint8_t		OUT11BCH ;
volatile __pdata __at (0x7f77) uint8_t		OUT11BCL ;
volatile __pdata __at (0x7f78) uint8_t		OUT12BCH ;
volatile __pdata __at (0x7f79) uint8_t		OUT12BCL ;
volatile __pdata __at (0x7f7a) uint8_t		OUT13BCH ;
volatile __pdata __at (0x7f7b) uint8_t		OUT13BCL ;
volatile __pdata __at (0x7f7c) uint8_t		OUT14BCH ;
volatile __pdata __at (0x7f7d) uint8_t		OUT14BCL ;
volatile __pdata __at (0x7f7e) uint8_t		OUT15BCH ;
volatile __pdata __at (0x7f7f) uint8_t		OUT15BCL ;

/* CPU Registers */
volatile __pdata __at (0x7f92) uint8_t		CPUCS ;
volatile __pdata __at (0x7f93) uint8_t		PORTACFG ;
volatile __pdata __at (0x7f94) uint8_t		PORTBCFG ;
volatile __pdata __at (0x7f95) uint8_t		PORTCCFG ;

/* Input-Output Port Registers */
volatile __pdata __at (0x7f96) uint8_t		OUTA ;
volatile __pdata __at (0x7f97) uint8_t		OUTB ;
volatile __pdata __at (0x7f98) uint8_t		OUTC ;
volatile __pdata __at (0x7f99) uint8_t		PINSA ;
volatile __pdata __at (0x7f9a) uint8_t		PINSB ;
volatile __pdata __at (0x7f9b) uint8_t		PINSC ;
volatile __pdata __at (0x7f9c) uint8_t		OEA ;
volatile __pdata __at (0x7f9d) uint8_t		OEB ;
volatile __pdata __at (0x7f9e) uint8_t		OEC ;

/* Isochronous Control/Status Registers */
volatile __pdata __at (0x7fa0) uint8_t		ISOERR ;
volatile __pdata __at (0x7fa1) uint8_t		ISOCTL ;
volatile __pdata __at (0x7fa2) uint8_t		ZBCOUT ;

/* I2C Registers */
volatile __pdata __at (0x7fa5) uint8_t		I2CS ;
volatile __pdata __at (0x7fa6) uint8_t		I2DAT ;

/* Interrupts */
volatile __pdata __at (0x7fa8) uint8_t		IVEC ;
volatile __pdata __at (0x7fa9) uint8_t		IN07IRQ ;
volatile __pdata __at (0x7faa) uint8_t		OUT07IRQ ;
volatile __pdata __at (0x7fab) uint8_t		USBIRQ ;
volatile __pdata __at (0x7fac) uint8_t		IN07IEN ;
volatile __pdata __at (0x7fad) uint8_t		OUT07IEN ;
volatile __pdata __at (0x7fae) uint8_t		USBIEN ;
volatile __pdata __at (0x7faf) uint8_t		USBBAV ;
volatile __pdata __at (0x7fb2) uint8_t		BPADDRH ;
volatile __pdata __at (0x7fb3) uint8_t		BPADDRL ;

/* Bulk Endpoints 0-7 */
volatile __pdata __at (0x7fb4) uint8_t		EP0CS ;
volatile __pdata __at (0x7fb5) uint8_t		IN0BC ;
volatile __pdata __at (0x7fb6) uint8_t		IN1CS ;
volatile __pdata __at (0x7fb7) uint8_t		IN1BC ;
volatile __pdata __at (0x7fb8) uint8_t		IN2CS ;
volatile __pdata __at (0x7fb9) uint8_t		IN2BC ;
volatile __pdata __at (0x7fba) uint8_t		IN3CS ;
volatile __pdata __at (0x7fbb) uint8_t		IN3BC ;
volatile __pdata __at (0x7fbc) uint8_t		IN4CS ;
volatile __pdata __at (0x7fbd) uint8_t		IN4BC ;
volatile __pdata __at (0x7fbe) uint8_t		IN5CS ;
volatile __pdata __at (0x7fbf) uint8_t		IN5BC ;
volatile __pdata __at (0x7fc0) uint8_t		IN6CS ;
volatile __pdata __at (0x7fc1) uint8_t		IN6BC ;
volatile __pdata __at (0x7fc2) uint8_t		IN7CS ;
volatile __pdata __at (0x7fc3) uint8_t		IN7BC ;
volatile __pdata __at (0x7fc5) uint8_t		OUT0BC ;
volatile __pdata __at (0x7fc6) uint8_t		OUT1CS ;
volatile __pdata __at (0x7fc7) uint8_t		OUT1BC ;
volatile __pdata __at (0x7fc8) uint8_t		OUT2CS ;
volatile __pdata __at (0x7fc9) uint8_t		OUT2BC ;
volatile __pdata __at (0x7fca) uint8_t		OUT3CS ;
volatile __pdata __at (0x7fcb) uint8_t		OUT3BC ;
volatile __pdata __at (0x7fcc) uint8_t		OUT4CS ;
volatile __pdata __at (0x7fcd) uint8_t		OUT4BC ;
volatile __pdata __at (0x7fce) uint8_t		OUT5CS ;
volatile __pdata __at (0x7fcf) uint8_t		OUT5BC ;
volatile __pdata __at (0x7fd0) uint8_t		OUT6CS ;
volatile __pdata __at (0x7fd1) uint8_t		OUT6BC ;
volatile __pdata __at (0x7fd2) uint8_t		OUT7CS ;
volatile __pdata __at (0x7fd3) uint8_t		OUT7BC ;

/* Global USB Registers */
volatile __pdata __at (0x7fd4) uint8_t		SUDPTRH ;
volatile __pdata __at (0x7fd5) uint8_t		SUDPTRL ;
volatile __pdata __at (0x7fd6) uint8_t		USBCS ;
volatile __pdata __at (0x7fd7) uint8_t		TOGCTL ;
volatile __pdata __at (0x7fd8) uint8_t		USBFRAMEL ;
volatile __pdata __at (0x7fd9) uint8_t		USBFRAMEH ;
volatile __pdata __at (0x7fdb) uint8_t		FNADDR ;
volatile __pdata __at (0x7fdd) uint8_t		USBPAIR ;
volatile __pdata __at (0x7fde) uint8_t		IN07VAL ;
volatile __pdata __at (0x7fdf) uint8_t		OUT07VAL ;
volatile __pdata __at (0x7fe0) uint8_t		INISOVAL ;
volatile __pdata __at (0x7fe1) uint8_t		OUTISOVAL ;
volatile __pdata __at (0x7fe2) uint8_t		FASTXFR ;
volatile __pdata __at (0x7fe3) uint8_t		AUTOPTRH ;
volatile __pdata __at (0x7fe4) uint8_t		AUTOPTRL ;
volatile __pdata __at (0x7fe5) uint8_t		AUTODATA ;

/* Setup Data */
volatile __pdata __at (0x7fe8) uint8_t		SETUPDAT[8] ;

/* Isochronous FIFO Sizes */
volatile __pdata __at (0x7ff0) uint8_t		OUT8ADDR ;
volatile __pdata __at (0x7ff1) uint8_t		OUT9ADDR ;
volatile __pdata __at (0x7ff2) uint8_t		OUT10ADDR ;
volatile __pdata __at (0x7ff3) uint8_t		OUT11ADDR ;
volatile __pdata __at (0x7ff4) uint8_t		OUT12ADDR ;
volatile __pdata __at (0x7ff5) uint8_t		OUT13ADDR ;
volatile __pdata __at (0x7ff6) uint8_t		OUT14ADDR ;
volatile __pdata __at (0x7ff7) uint8_t		OUT15ADDR ;
volatile __pdata __at (0x7ff8) uint8_t		IN8ADDR ;
volatile __pdata __at (0x7ff9) uint8_t		IN9ADDR ;
volatile __pdata __at (0x7ffa) uint8_t		IN19ADDR ;
volatile __pdata __at (0x7ffb) uint8_t		IN11ADDR ;
volatile __pdata __at (0x7ffc) uint8_t		IN12ADDR ;
volatile __pdata __at (0x7ffd) uint8_t		IN13ADDR ;
volatile __pdata __at (0x7ffe) uint8_t		IN14ADDR ;
volatile __pdata __at (0x7fff) uint8_t		IN15ADDR ;


#endif/*__EZUSB__REGS_H__INCLUDED__*/
