/* ================================================================================ */
/*   ezusb/spi.c                                                                    */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"


static __NEAR uint8_t				m_mode ;						/* SPI [h */


/* -------------------------------------------------------------------------------- */
/*   [hݒ                                                                     */
/*                                                                                  */
/*   IN : mode = [h                                                             */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void spi_mode( uint8_t mode ) __naked
{
	mode = mode ;

	__asm__(
	"MPAGE		=	_MPAGE								\n"
	"OUTA		=	_OUTA								\n"
	"OUTB		=	_OUTB								\n"
	"OUTC		=	_OUTC								\n"
	"PINSA		=	_PINSA								\n"
	"PINSB		=	_PINSB								\n"
	"PINSC		=	_PINSC								\n"
	"SCLK		=	" SPI_SCLK                         "\n"
	"SCLK_BIT	=	" SPI_SCLK_BIT                     "\n"
	"MOSI		=	" SPI_MOSI                         "\n"
	"MOSI_BIT	=	" SPI_MOSI_BIT                     "\n"
	"MISO		=	" SPI_MISO                         "\n"
	"MISO_BIT	=	" SPI_MISO_BIT                     "\n"
	"													\n"
	"													\n"
	"	MOV		A, DPL									\n"
	"	MOV		_m_mode, A								\n"
	"													\n"
	"	MOV		C, ACC.3								\n"
	"	MOV		A, #(1<<MOSI_BIT)						\n"
	"	MOV		ACC+SCLK_BIT, C							\n"
	"													\n"
	"	MOV		R0, #SCLK								\n"
	"	MOVX	@R0, A									\n"
	"	RET												\n"
	) ;
}


/* -------------------------------------------------------------------------------- */
/*   Wrbg]                                                                   */
/*                                                                                  */
/*   IN : sendData = Mf[^                                                     */
/*   OUT: Mf[^                                                                */
/* -------------------------------------------------------------------------------- */
uint8_t spi_xfer8( uint8_t sendData ) __naked
{
	sendData = sendData ;

	__asm__(
	"	MOV		R0, #SCLK								\n"
	"	MOV		R1, #MISO								\n"
	"	MOV		R3, DPL									\n"
	"	MOV		R4, #8									\n"
	"	MOV		R5, #(1<<SCLK_BIT)						\n"
	"													\n"
	"	MOV		DPTR, #spi_xfer_jmptbl					\n"
	"	MOV		A, _m_mode								\n"
	"	JMP		@A+DPTR									\n"
	"													\n"
	"spi_xfer_jmptbl:									\n"
	"	MOV		R2, #0x00				; [h 0		\n"
	"	SJMP	spi_xfer_mode02							\n"
	"	MOV		R2, #0x00				; [h 1		\n"
	"	SJMP	spi_xfer_mode13							\n"
	"	MOV		R2, #(1<<SCLK_BIT)		; [h 2		\n"
	"	SJMP	spi_xfer_mode02							\n"
	"	MOV		R2, #(1<<SCLK_BIT)		; [h 3		\n"
	"	SJMP	spi_xfer_mode13							\n"
	"													\n"
	"; ------------------------------------------------ \n"
	";   [h 0/2                                     \n"
	"; ------------------------------------------------ \n"
	"spi_xfer_mode02:									\n"
	"	DEC		R4										\n"
	"													\n"
	"	MOV		A, R3					; 1				\n"
	"	RLC		A						; 1				\n"
	"	MOV		R3, A					; 1				\n"
	"													\n"
	"	; MOSI o										\n"
	"	MOV		A, R2					; 1				\n"
	"	MOV		ACC+MOSI_BIT, C			; 2				\n"
	"	MOVX	@R0, A					; 2				\n"
	"													\n"
	"spi_xfer_mode02_100:								\n"
	"	; オij							\n"
	"	XRL		A, R5					; 1				\n"
	"	MOV		R2, A					; 1				\n"
	"	MOVX	@R0, A					; 2				\n"
	"	MOVX	A, @R1					; 2				\n"
	"	MOV		C, ACC+MISO_BIT			; 2				\n"
	"													\n"
	"	MOV		A, R3					; 1				\n"
	"	RLC		A						; 1				\n"
	"													\n"
	"	; iオj							\n"
	"	XCH		A, R2					; 1				\n"
	"	XRL		A, R5					; 1				\n"
	"	MOV		ACC+MOSI_BIT, C			; 2				\n"
	"	MOVX	@R0, A					; 2				\n"
	"													\n"
	"	; f[^߂									\n"
	"	XCH		A, R2					; 1				\n"
	"	MOV		R3, A					; 1				\n"
	"	MOV		A, R2					; 1				\n"
	"													\n"
	"	NOP								; 1				\n"
	"	NOP								; 1				\n"
	"	DJNZ	R4, spi_xfer_mode02_100	; 3				\n"

	"	; オij							\n"
	"	XRL		A, R5					; 1				\n"
	"	MOV		R2, A					; 1				\n"
	"	MOVX	@R0, A					; 2				\n"
	"	MOVX	A, @R1					; 2				\n"
	"	MOV		C, ACC+MISO_BIT			; 2				\n"
	"													\n"
	"	MOV		A, R3					; 1				\n"
	"	RLC		A						; 1				\n"
	"													\n"
	"	; iオj							\n"
	"	XCH		A, R2					; 1				\n"
	"	XRL		A, R5					; 1				\n"
	"	NOP								; 1				\n"
	"	NOP								; 1				\n"
	"	MOVX	@R0, A					; 2				\n"
	"													\n"
	"	MOV		DPL, R2									\n"
	"	RET												\n"
	"													\n"
	"; ------------------------------------------------ \n"
	";   [h 1/3                                     \n"
	"; ------------------------------------------------ \n"
	"spi_xfer_mode13_000:								\n"
	"	; 									\n"
	"	XRL		A, R5					; 1				\n"
	"	MOV		R2, A					; 1				\n"
	"	MOVX	@R0, A					; 2				\n"
	"	MOVX	A, @R1					; 2				\n"
	"	MOV		C, ACC+MISO_BIT			; 2				\n"
	"													\n"
	"spi_xfer_mode13:									\n"
	"	MOV		A, R3					; 1				\n"
	"	RLC		A						; 1				\n"
	"													\n"
	"	; オij							\n"
	"	XCH		A, R2					; 1				\n"
	"	XRL		A, R5					; 1				\n"
	"	MOV		ACC+MOSI_BIT, C			; 2				\n"
	"	MOVX	@R0, A					; 2				\n"
	"													\n"
	"	; f[^߂									\n"
	"	XCH		A, R2					; 1				\n"
	"	MOV		R3, A					; 1				\n"
	"	MOV		A, R2					; 1				\n"
	"													\n"
	"	NOP								; 1				\n"
	"	NOP								; 1				\n"
	"	DJNZ	R4, spi_xfer_mode13_000	; 3				\n"
	"													\n"
	"	; iオj							\n"
	"	XRL		A, R5					; 1				\n"
	"	MOV		R2, A					; 1				\n"
	"	MOVX	@R0, A					; 2				\n"
	"	MOVX	A, @R1					; 2				\n"
	"	MOV		C, ACC+MISO_BIT			; 2				\n"
	"													\n"
	"	MOV		A, R3					; 1				\n"
	"	RLC		A						; 1				\n"
	"	MOV		DPL, A									\n"
	"	RET												\n"
	) ;
}
