/* ================================================================================ */
/*   ezusb/usb.c                                                                    */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"
#include "usb.h"

#if 0
extern void puts( const char __code *p_string ) ;
#else
#define puts						//
#endif


extern const uint8_t				g_usbDeviceDscr[] ;				/* usb_dscr.asm */
extern const uint8_t				g_usbHidReportDscr[42] ;		/*              */
extern const uint8_t				g_usbConfigDscr[] ;				/*              */
extern const uint16_t				g_usbStringDscr[4] ;			/*              */


static __data uint8_t				m_interface ;


/* -------------------------------------------------------------------------------- */
/*   obt@̓eGh|CgOőM                                         */
/*                                                                                  */
/*   IN : p_buff = Mobt@                                                     */
/*        length = Mobt@                                                   */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
static void sendBuffer(const uint8_t __code *p_buff, uint8_t length)
{
	uint8_t		index, count ;


	while( length ) {
		/* Rs[TCY */
		count = length ;
		if( count > sizeof( IN0BUF ) ) {
			count = sizeof( IN0BUF ) ;
		}
		length -= count ;

		/* Rs[ */
		for(index=0; index<count; index++) {
			IN0BUF[index] = *p_buff++ ;
		}

		IN0BC = count ;

		/* M҂ */
		while( EP0CS & EP0CS_INBSY ) {
			;
		}
	}
}


/* -------------------------------------------------------------------------------- */
/*   ؒfEĐڑ                                                                   */
/*                                                                                  */
/*   IN : renum = 0:Gj[VȂ                                          */
/*                1:Gj[V                                          */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void disconnect( __bit renum )
{
	/* ؒf */
	USBCS |=  USBCS_DISCON ;
	nop() ;
	nop() ;
	nop() ;

	USBCS &= ~USBCS_DISCOE ;
	nop() ;
	nop() ;
	nop() ;

	USBCS |=  USBCS_DISCON ;

	/* ăGj[V */
	if( renum ) {
		USBCS |= USBCS_RENUM ;
	}

	dly_tsk( 1500 ) ;

	USBIRQ   = USBIRQ_URESIR | USBIRQ_SUSPIR | USBIRQ_SUTOKIR | USBIRQ_SOFIR | USBIRQ_SUDAVIR ;
	IN07IRQ  = 0xff ;
	OUT07IRQ = 0xff ;
	EXIF    &= ~EXIF_USBINT ;

	/* Đڑ */
	USBCS &= ~USBCS_DISCON ;
	nop() ;
	nop() ;
	nop() ;

	USBCS |=  USBCS_DISCOE ;
}


// -------------------------------------------------------------------------------- 
//   foCXEC^tF[XEGh|Cg̋@\̏Ԃ擾                     
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: 0 = I                                                              
//        1 = Xg[                                                              
// -------------------------------------------------------------------------------- 
static __bit getStatus( void )
{
	switch( SETUPDAT[0] ) {
		case GS_DEVICE:
		case GS_INTERFACE:
		case GS_ENDPOINT:
		{
			IN0BUF[0] = 0x00 ;
			IN0BUF[1] = 0x00 ;
			IN0BC     = 2 ;
			break ;
		}

		default:
			return 1 ;
	}

	return 0 ;
}


// -------------------------------------------------------------------------------- 
//   foCXEC^tF[XEGh|Cg̋@\𖳌                           
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: 0 = I                                                              
//        1 = Xg[                                                              
// -------------------------------------------------------------------------------- 
static __bit clearFeature( void )
{
	switch( SETUPDAT[0] ) {
		case FT_DEVICE:
		{
			if( SETUPDAT[2] != 1 ) {
				return 1 ;
			}
			break ;
		}

		case FT_ENDPOINT:
		{
			if( !SETUPDAT[2] ) {
				return 1 ;
			}
			break ;
		}

		default:
			return 1 ;
	}

	return 0 ;
}


// -------------------------------------------------------------------------------- 
//   foCXEC^tF[XEGh|Cg̋@\ݒ                           
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: 0 = I                                                              
//        1 = Xg[                                                              
// -------------------------------------------------------------------------------- 
static __bit setFeature( void )
{
	switch( SETUPDAT[0] ) {
		case FT_DEVICE:
		{
			if( SETUPDAT[2] != 1 ) {
				return 1 ;
			}
			break ;
		}

		case FT_ENDPOINT:
		{
			break ;
		}

		default:
			return 1 ;
	}

	return 0 ;
}


// -------------------------------------------------------------------------------- 
//   fBXNv^擾                                                           
//                                                                                  
//   IN : Ȃ                                                                      
//   OUT: 0 = I                                                              
//        1 = Xg[                                                              
// -------------------------------------------------------------------------------- 
static __bit getDescriptor( void )
{
	switch( SETUPDAT[3] ) {
		case GD_DEVICE:
		{
			puts( "GD_DEVICE" ) ;

			if( SETUPDAT[2] ) {
				return 1 ;
			}

			SUDPTRH = MSB( g_usbDeviceDscr ) ;
			SUDPTRL = LSB( g_usbDeviceDscr ) ;
			break ;
		}

		case GD_CONFIGURATION:
		{
			puts( "GD_CONFIGURATION" ) ;

			if( SETUPDAT[2] ) {
				return 1 ;
			}

			SUDPTRH = MSB( g_usbConfigDscr ) ;
			SUDPTRL = LSB( g_usbConfigDscr ) ;
			break ;
		}

		case GD_STRING:
		{
			uint8_t		index ;
			uint16_t	stringDscr ;


			puts( "GD_STRING" ) ;

			index = SETUPDAT[2] ;
			if( index >= (sizeof( g_usbStringDscr )/sizeof( g_usbStringDscr[0] )) ) {
				return 1 ;
			}

			stringDscr = g_usbStringDscr[index] ;
			SUDPTRH    = MSB( stringDscr ) ;
			SUDPTRL    = LSB( stringDscr ) ;
			break ;
		}

		case GD_REPORT:
		{
			puts( "GD_REPORT" ) ;

			sendBuffer(&g_usbHidReportDscr[0], sizeof( g_usbHidReportDscr )) ;

			/* eXgp^C}NiƂ肠ŋNj */
			sta_cyc( USB_CYCID ) ;
			break ;
		}

		default:
		{
			puts( "UNKNOWN" ) ;

			return 1 ;
		}
	}

	return 0 ;
}


/* -------------------------------------------------------------------------------- */
/*   USB ^XN                                                                     */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_tsk( void )
{
	__bit	stall ;


	loc_cpu() ;

	IN07VAL  = IN07VAL_IN1VAL ;							/* IN  Gh|Cgݒ         */
	OUT07VAL = 0x00 ;									/* OUT Gh|Cgݒ         */
	IN07IEN  = 0x00 ;									/* IN  Gh|Cg荞ݐݒ */
	OUT07IEN = 0x00 ;									/* OUT Gh|Cg荞ݐݒ */
	EUSB     = 1 ;										/* USBINT 荞                */
	ERESI    = 1 ;										/* W[荞             */
	USBBAV   = USBBAV_AVEN ;							/* I[gxN^L               */
														/* USB 荞ݐݒ               */
	USBIEN   = USBIEN_URESIE | USBIEN_SUSPIE | USBIEN_SUTOKIE | USBIEN_SUDAVIE ;

	unl_cpu() ;

	disconnect( TRUE ) ;

	while( 1 ) {
		stall = 0 ;

		wai_sem( USB_SEMID ) ;

#if 0
{
	static const char	hexAscii[]="0123456789ABCDEF" ;

	putchar( hexAscii[SETUPDAT[0]>>4] ) ;
	putchar( hexAscii[SETUPDAT[0]&15] ) ;
	putchar( ',' ) ;
	putchar( hexAscii[SETUPDAT[1]>>4] ) ;
	putchar( hexAscii[SETUPDAT[1]&15] ) ;
	putchar( ',' ) ;
	putchar( hexAscii[SETUPDAT[3]>>4] ) ;
	putchar( hexAscii[SETUPDAT[3]&15] ) ;
	putchar( hexAscii[SETUPDAT[2]>>4] ) ;
	putchar( hexAscii[SETUPDAT[2]&15] ) ;
	putchar( ',' ) ;
	putchar( hexAscii[SETUPDAT[5]>>4] ) ;
	putchar( hexAscii[SETUPDAT[5]&15] ) ;
	putchar( hexAscii[SETUPDAT[4]>>4] ) ;
	putchar( hexAscii[SETUPDAT[4]&15] ) ;
	putchar( ',' ) ;
	putchar( hexAscii[SETUPDAT[7]>>4] ) ;
	putchar( hexAscii[SETUPDAT[7]&15] ) ;
	putchar( hexAscii[SETUPDAT[6]>>4] ) ;
	putchar( hexAscii[SETUPDAT[6]&15] ) ;
	puts( " - " ) ;
}
#endif


		switch( SETUPDAT[1] ) {
			case SC_GET_STATUS:
			{
				puts( "SC_GET_STATUS" ) ;

				stall = getStatus() ;
				break ;
			}

			case SC_CLEAR_FEATURE:
			{
				puts( "SC_CLEAR_FEATURE" ) ;

				stall = clearFeature() ;
				break ;
			}

			case SC_SET_FEATURE:
			{
				puts( "SC_SET_FEATURE" ) ;

				stall = setFeature() ;
				break ;
			}

			case SC_SET_ADDRESS:
			{
				puts( "SC_SET_ADDRESS" ) ;
				break ;
			}

			case SC_GET_DESCRIPTOR:
			{
				puts( "SC_GET_DESCRIPTOR : " ) ;

				stall = getDescriptor() ;
				break ;
			}

			case SC_SET_DESCRIPTOR:
			{
				puts( "SC_SET_DESCRIPTOR" ) ;

				stall = 1 ;
				break ;
			}

			case SC_GET_CONFIGURATION:
			{
				puts( "SC_GET_CONFIGURATION" ) ;

				IN0BUF[0] = 0 ;
				IN0BC     = 1 ;
				break ;
			}

			case SC_SET_CONFIGURATION:
			{
				puts( "SC_SET_CONFIGURATION" ) ;
				break ;
			}

			case SC_GET_INTERFACE:
			{
				puts( "SC_GET_INTERFACE" ) ;

				IN0BUF[0] = m_interface ;
				IN0BC     = 1 ;
				break ;
			}

			case SC_SET_INTERFACE:
			{
				puts( "SC_SET_INTERFACE" ) ;

				m_interface = SETUPDAT[2] ;
				break ;
			}

			case SC_SYNC_FRAME:
			{
				puts( "SC_SYNC_FRAME" ) ;

				stall = 1 ;
				break ;
			}

			default:
			{
				puts( "UNKNOWN" ) ;

				stall = 1 ;
				break ;
			}
		}

		if( stall ) {
			EP0CS |= (EP0CS_HSNAK | EP0CS_EP0STALL) ;
		} else {
			EP0CS |=  EP0CS_HSNAK ;
		}

		puts( "\r\n" ) ;
	}
}


/* -------------------------------------------------------------------------------- */
/*   SUDAV 荞݃T[rX[`                                                 */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_sudav( void )
{
	isig_sem( USB_SEMID ) ;

	EXIF  &= ~EXIF_USBINT ;
	USBIRQ =  USBIRQ_SUDAVIR ;
}


/* -------------------------------------------------------------------------------- */
/*   SOF 荞݃T[rX[`                                                   */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_sof( void ) __interrupt(1) INTPROC
{
	EXIF  &= ~EXIF_USBINT ;
	USBIRQ =  USBIRQ_SOFIR ;
}


/* -------------------------------------------------------------------------------- */
/*   SUTOK 荞݃T[rX[`                                                 */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_sutok( void ) __interrupt(2) INTPROC
{
	EXIF  &= ~EXIF_USBINT ;
	USBIRQ =  USBIRQ_SUTOKIR ;
}


/* -------------------------------------------------------------------------------- */
/*   SUSPEND 荞݃T[rX[`                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_suspend( void ) __interrupt(3) INTPROC
{
	EXIF  &= ~EXIF_USBINT ;
	USBIRQ =  USBIRQ_SUSPIR ;
}


/* -------------------------------------------------------------------------------- */
/*   USB RESET 荞݃T[rX[`                                             */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_usbres( void ) __interrupt(4) INTPROC
{
	IN1BC = 0 ;
	IN2BC = 0 ;
	IN3BC = 0 ;
	IN4BC = 0 ;
	IN5BC = 0 ;
	IN6BC = 0 ;
	IN7BC = 0 ;

	EXIF  &= ~EXIF_USBINT ;
	USBIRQ =  USBIRQ_URESIR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP0-IN 荞݃T[rX[`                                                */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep0in( void ) __interrupt(6) INTPROC
{
//#	EXIF   &= ~EXIF_USBINT ;
//#	IN07IRQ =  IN07IRQ_IN0IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP0-OUT 荞݃T[rX[`                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep0out( void ) __interrupt(7) INTPROC
{
//#	OUT0BC = 0 ;
//#
//#	EXIF    &= ~EXIF_USBINT ;
//#	OUT07IRQ =  OUT07IRQ_OUT0IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP1-IN 荞݃T[rX[`                                                */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep1in( void ) __interrupt(8) INTPROC
{
//#	EXIF   &= ~EXIF_USBINT ;
//#	IN07IRQ =  IN07IRQ_IN1IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP1-OUT 荞݃T[rX[`                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep1out( void ) __interrupt(9) INTPROC
{
//#	OUT1BC = 0 ;
//#
//#	EXIF    &= ~EXIF_USBINT ;
//#	OUT07IRQ =  OUT07IRQ_OUT1IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP2-IN 荞݃T[rX[`                                                */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep2in( void ) __interrupt(10) INTPROC
{
//#	EXIF   &= ~EXIF_USBINT ;
//#	IN07IRQ =  IN07IRQ_IN2IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP2-OUT 荞݃T[rX[`                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep2out( void ) __interrupt(11) INTPROC
{
//#	OUT2BC = 0 ;
//#
//#	EXIF    &= ~EXIF_USBINT ;
//#	OUT07IRQ =  OUT07IRQ_OUT2IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP3-IN 荞݃T[rX[`                                                */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep3in( void ) __interrupt(12) INTPROC
{
//#	EXIF   &= ~EXIF_USBINT ;
//#	IN07IRQ =  IN07IRQ_IN3IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP3-OUT 荞݃T[rX[`                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep3out( void ) __interrupt(13) INTPROC
{
//#	OUT3BC = 0 ;
//#
//#	EXIF    &= ~EXIF_USBINT ;
//#	OUT07IRQ =  OUT07IRQ_OUT3IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP4-IN 荞݃T[rX[`                                                */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep4in( void ) __interrupt(14) INTPROC
{
//#	EXIF   &= ~EXIF_USBINT ;
//#	IN07IRQ =  IN07IRQ_IN4IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP4-OUT 荞݃T[rX[`                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep4out( void ) __interrupt(15) INTPROC
{
//#	OUT4BC = 0 ;
//#
//#	EXIF    &= ~EXIF_USBINT ;
//#	OUT07IRQ =  OUT07IRQ_OUT4IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP5-IN 荞݃T[rX[`                                                */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep5in( void ) __interrupt(16) INTPROC
{
//#	EXIF   &= ~EXIF_USBINT ;
//#	IN07IRQ =  IN07IRQ_IN5IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP5-OUT 荞݃T[rX[`                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep5out( void ) __interrupt(17) INTPROC
{
//#	OUT5BC = 0 ;
//#
//#	EXIF    &= ~EXIF_USBINT ;
//#	OUT07IRQ =  OUT07IRQ_OUT5IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP6-IN 荞݃T[rX[`                                                */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep6in( void ) __interrupt(18) INTPROC
{
//#	EXIF   &= ~EXIF_USBINT ;
//#	IN07IRQ =  IN07IRQ_IN6IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP6-OUT 荞݃T[rX[`                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep6out( void ) __interrupt(19) INTPROC
{
//#	OUT6BC = 0 ;
//#
//#	EXIF    &= ~EXIF_USBINT ;
//#	OUT07IRQ =  OUT07IRQ_OUT6IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP7-IN 荞݃T[rX[`                                                */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep7in( void ) __interrupt(20) INTPROC
{
//#	EXIF   &= ~EXIF_USBINT ;
//#	IN07IRQ =  IN07IRQ_IN7IR ;
}


/* -------------------------------------------------------------------------------- */
/*   EP7-OUT 荞݃T[rX[`                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_isr_ep7out( void ) __interrupt(21) INTPROC
{
//#	OUT7BC = 0 ;
//#
//#	EXIF    &= ~EXIF_USBINT ;
//#	OUT07IRQ =  OUT07IRQ_OUT7IR ;
}


/* -------------------------------------------------------------------------------- */
/*   USB eXgp^C}nh                                                 */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void usb_cychdr( void ) INTPROC
{
	static const uint16_t	padData[]={
								0x0100, 0x0500,		/*        */
								0x0100, 0x0500,		/*        */
								0x0900, 0x0500,		/*        */
								0x0900, 0x0500,		/*        */
								0x0400, 0x0500,		/*        */
								0x0600, 0x0500,		/* E       */
								0x0400, 0x0500,		/*        */
								0x0600, 0x0500,		/* E       */
								0x1500, 0x0500,		/* {^P */
								0x2500, 0x0500		/* {^Q */
							} ;
	static uint8_t			count=0 ;


	IN1BUF[0] = (uint8_t )(padData[count] >> 8) ;
	IN1BUF[1] = (uint8_t )(padData[count] >> 0) ;
	IN1BC     = 2 ;

	if( ++count == (sizeof( padData )/sizeof( padData[0] )) ) {
		count = 0 ;
	}
}
