; ================================================================================ 
;   ezusb/usb_dscr.asm                                                             
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

	.module usb_dscr

	.include "kernel.inc"
	.include "usb.inc"


	.area	CSEGEVEN (CODE)


; -------------------------------------------------------------------------------- 
;   foCXfBXNv^                                                         
; -------------------------------------------------------------------------------- 
	.even
_g_usbDeviceDscr::
	.DB	_g_usbDeviceDscrEnd-.				; fBXNv^
	.DB	DSCR_DEVICE					; fBXNv^
	.DWL	0x0110						; USB dl[XԍiBCDj
	.DB	0x00						; NXR[h
	.DB	0x00						; TuNXR[h
	.DB	0x00						; vgRR[h
	.DB	64						; Gh|CgO̍őpPbg
	.DWL	0x0547						; x_ʎq
	.DWL	0x2001						; v_Ngʎq
	.DWL	0x0100						; VAԍ
	.DB	1						; x_̃XgOfBXNv^̃CfbNX
	.DB	2						; v_Ng̃XgOfBXNv^̃CfbNX
	.DB	3						; VAԍ̃XgOfBXNv^̃CfbNX
	.DB	1						; RtBM[V
_g_usbDeviceDscrEnd:


; -------------------------------------------------------------------------------- 
;   HID |[gfBXNv^                                                     
; -------------------------------------------------------------------------------- 
_g_usbHidReportDscr::
	.DB	0x05, 0x01					; USAGE_PAGE (Generic Desktop)
	.DB	0x09, 0x04					; USAGE (Joystick)
	.DB	0xa1, 0x01					; COLLECTION (Application)
	.DB	0x09, 0x01					;   USAGE (Pointer)
	.DB	0xa1, 0x00					;   COLLECTION (Physical)
	.DB	0x09, 0x30					;     USAGE (X)
	.DB	0x09, 0x31					;     USAGE (Y)
	.DB	0x15, 0x00					;     LOGICAL_MINIMUM (0)
	.DB	0x25, 0x02					;     LOGICAL_MAXIMUM (2)
	.DB	0x75, 0x02					;     REPORT_SIZE (2)
	.DB	0x95, 0x02					;     REPORT_COUNT (2)
	.DB	0x81, 0x02					;     INPUT (Data,Var,Abs)
	.DB	0xc0						;   END_COLLECTION
	.DB	0x05, 0x09					;   USAGE_PAGE (Button)
	.DB	0x19, 0x01					;   USAGE_MINIMUM (Button 1)
	.DB	0x29, 0x0c					;   USAGE_MAXIMUM (Button 12)
	.DB	0x15, 0x00					;   LOGICAL_MINIMUM (0)
	.DB	0x25, 0x01					;   LOGICAL_MAXIMUM (1)
	.DB	0x75, 0x01					;   REPORT_SIZE (1)
	.DB	0x95, 0x0c					;   REPORT_COUNT (12)
	.DB	0x81, 0x02					;   INPUT (Data,Var,Abs)
	.DB	0xc0						; END_COLLECTION
_g_usbHidReportDscrEnd:


; -------------------------------------------------------------------------------- 
;   RtBM[VfBXNv^                                            
; -------------------------------------------------------------------------------- 
	.even
_g_usbConfigDscr::
	.DB	_g_usbInterfaceDscr-.				; fBXNv^
	.DB	DSCR_CONFIG					; fBXNv^
	.DWL	_g_usbConfigDscrEnd-_g_usbConfigDscr		; SẴfBXNv^
	.DB	1						; C^tF[X
	.DB	1						; RtBM[Vԍ
	.DB	0						; RtBM[ṼXgOfBXNv^̃CfbNX
	.DB	0b10100000					; ioXp[A[gEF[NAbvT|[gj
	.DB	100/2						; KvȃoXdiődl 1/2j

_g_usbInterfaceDscr:						; C^tF[XO
	.DB	_g_usbHidDscr-.					;   fBXNv^
	.DB	DSCR_INTERFACE					;   fBXNv^
	.DB	0						;   C^tF[Xʔԍ
	.DB	0						;   ֐ݒ̑Il
	.DB	1						;   Gh|Cg
	.DB	CLASS_HID					;   NXR[h
	.DB	0x00						;   TuNXR[h
	.DB	0x00						;   vgRR[h
	.DB	0						;   C^tF[X̃XgOfBXNv^̃CfbNX
_g_usbHidDscr:							; HID
	.DB	_g_usbEndpointDscr-.				;   fBXNv^
	.DB	DSCR_HID					;   fBXNv^
	.DWL	0x0110						;   HID dl[XԍiBCDj
	.DB	0x00						;   ʃR[h
	.DB	1						;   ]NXfBXNv^
	.DB	DSCR_HIDREPORT					;   fBXNv^
	.DWL	_g_usbHidReportDscrEnd-_g_usbHidReportDscr	;   |[gfBXNv^
_g_usbEndpointDscr:						; Gh|Cg
	ENDPOINT	0x81, ET_INT, 2, 15
_g_usbConfigDscrEnd:


; -------------------------------------------------------------------------------- 
;   XgOfBXNv^                                                       
; -------------------------------------------------------------------------------- 
	.even
stringDscr0:
	.DB	stringDscr1-.
	.DB	DSCR_STRING
	.DWL	0x0409

stringDscr1:
	.DB	stringDscr2-.
	.DB	DSCR_STRING
	.DWL	'l'
	.DWL	's'
	.DWL	'l'
	.DWL	'u'
	.DWL	'k'

stringDscr2:
	.DB	stringDscr3-.
	.DB	DSCR_STRING
	.DWL	'E'
	.DWL	'Z'
	.DWL	'-'
	.DWL	'U'
	.DWL	'S'
	.DWL	'B'
	.DWL	0x20
	.DWL	'T'
	.DWL	'e'
	.DWL	's'
	.DWL	't'

stringDscr3:
	.DB	_g_usbStringDscr-.
	.DB	DSCR_STRING
	.DWL	'0'
	.DWL	'.'
	.DWL	'0'
	.DWL	'1'

_g_usbStringDscr::
	.DWL	stringDscr0
	.DWL	stringDscr1
	.DWL	stringDscr2
	.DWL	stringDscr3


	.even
