/* ================================================================================ */
/*   ezusb_fx2/config.h                                                             */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __EZUSB_FX2__CONFIG_H__INCLUDED__
#define __EZUSB_FX2__CONFIG_H__INCLUDED__


#include "depend.h"

/* gphCo[` */
//#define CONFIG_UART
#define CONFIG_I2C
#define CONFIG_SPI
#define CONFIG_USB
//#define CONFIG_SC1602BS
#define CONFIG_ILI9325
#define CONFIG_AQM0802A
//#define CONFIG_AT24C
#define CONFIG_MCP3002
//#define CONFIG_MPL115A1
#define CONFIG_SDC

/* |[gݒ */
#define PORTA_DIR					PORT_DIR(_IN__,_OUT_,_OUT_,_OUT_,_OUT_,_OUT_,_OUT_,_OUT_)
#define PORTB_DIR					PORT_DIR(_IN__,_IN__,_IN__,_IN__,_IN__,_IN__,_IN__,_OUT_)
#define PORTC_DIR					PORT_DIR(_IN__,_IN__,_IN__,_IN__,_IN__,_IN__,_IN__,_IN__)
#define PORTD_DIR					PORT_DIR(_OUT_,_OUT_,_OUT_,_OUT_,_OUT_,_OUT_,_OUT_,_OUT_)
#define PORTE_DIR					PORT_DIR(_IN__,_IN__,_IN__,_IN__,_IN__,_IN__,_IN__,_IN__)


#include "regs.h"
#include "uart.h"
#include "i2c.h"
#include "spi.h"
#include "sdc.h"


/* ---------------------------------------------------------------- */
/*   UART                                                           */
/* ---------------------------------------------------------------- */
#define UART_TX_SEMID				1								/* MpZ}tH ID ԍ    */
#define UART_RX_SEMID				2								/* MpZ}tH ID ԍ    */
#define UART_SENDBUFF_SIZE			8								/* Mobt@TCYi2^nj */
#define UART_RECVBUFF_SIZE			8								/* Mobt@TCYi2^nj */
#define UART_COUNTER				0xf3							/* JE^i57600bpsj      */


/* ---------------------------------------------------------------- */
/*   I2C                                                            */
/* ---------------------------------------------------------------- */
#define I2C_SEMID					1								/* Z}tH ID ԍ               */
#define I2C_TMOUT					100								/* ^CAEg               */
#define I2C_400KHZ					1								/* ʐMxi0:100KHz, 1:400KHzj */


/* ---------------------------------------------------------------- */
/*   SPI                                                            */
/* ---------------------------------------------------------------- */
#define SPI_SCLK					"IOA_5"							/* SCLK pin */
#define SPI_MOSI					"IOA_6"							/* MOSI pin */
#define SPI_MISO					"IOA_7"							/* MISO pin */


/* ---------------------------------------------------------------- */
/*   USB                                                            */
/* ---------------------------------------------------------------- */
#define USB_SEMID					2								/* Z}tH ID ԍ                 */
#define USB_CYCID					3								/* USB eXgpnh ID ԍ */


/* ---------------------------------------------------------------- */
/*   SC1602BS                                                       */
/* ---------------------------------------------------------------- */
#define SC1602BS_LOCK()												/* bN                 */
#define SC1602BS_UNLOCK()											/* bN             */
#define SC1602BS_MODE				4								/* C^tF[Xrbg */
#define SC1602BS_E_LO()				IOD_5 = 0						/*  E pin Low             */
#define SC1602BS_E_HI()				IOD_5 = 1						/*  E pin High            */
#define SC1602BS_RS_LO()			IOD_4 = 0						/* RS pin Low             */
#define SC1602BS_RS_HI()			IOD_4 = 1						/* RS pin High            */
																	/* DB pin                 */
#define SC1602BS_DB( n )			\
{									\
	IOD_3 = ((n) >> 7) & 1 ;		\
	IOD_2 = ((n) >> 6) & 1 ;		\
	IOD_1 = ((n) >> 5) & 1 ;		\
	IOD_0 = ((n) >> 4) & 1 ;		\
}

#define SC1602BS_WAIT40ns()											/*  40ns ȏ҂         */
#define SC1602BS_WAIT220ns()		{ nop() ;  nop() ;  nop() ; }	/* 220ns ȏ҂         */
#define SC1602BS_WAIT40us()			wait10us( 4 )					/*  40us ȏ҂         */
#define SC1602BS_WAIT100us()		wait10us( 10 )					/* 100us ȏ҂         */
#define SC1602BS_WAIT1_6ms()		dly_tsk( 2 )					/* 1.6ms ȏ҂         */
#define SC1602BS_WAIT4_1ms()		dly_tsk( 5 )					/* 4.1ms ȏ҂         */
#define SC1602BS_WAIT15ms()			dly_tsk( 15 )					/*  15ms ȏ҂         */


/* ---------------------------------------------------------------- */
/*   ILI9325                                                        */
/* ---------------------------------------------------------------- */
#define ILI9325_8BIT												/* C^tF[X[h */
#define ILI9325_CS_LO()				IOA_2 = 0						/*    nCS pin Low       */
#define ILI9325_CS_HI()				IOA_2 = 1						/*    nCS pin High      */
#define ILI9325_RS_LO()				IOA_3 = 0						/*     RS pin Low       */
#define ILI9325_RS_HI()				IOA_3 = 1						/*     RS pin High      */
#define ILI9325_RST_LO()			IOA_1 = 0						/* nRESET pin Low       */
#define ILI9325_RST_HI()			IOA_1 = 1						/* nRESET pin High      */
#define ILI9325_WR_LO()				IOA_4 = 0						/*    nWR pin Low       */
#define ILI9325_WR_HI()				IOA_4 = 1						/*    nWR pin High      */
#define ILI9325_DB( n )				IOD   = (n)						/*     DB pin           */
#define ILI9325_WAITms( ms )		dly_tsk( ms )					/* w ms ȏ҂     */


/* ---------------------------------------------------------------- */
/*   AQM0802A                                                       */
/* ---------------------------------------------------------------- */
#define AQM0802A_LOCK()												/* bN          */
#define AQM0802A_UNLOCK()											/* bN      */
#define AQM0802A_SEND				i2c_send						/* M        */
																	/* 1.08ms ȏ҂ */
#define AQM0802A_WAIT26_3us()		wait10us( 27 )					/* 26.3us ȏ҂ */
#define AQM0802A_WAIT1_08ms()		{ dly_tsk( 1 ) ;  wait10us( 8 ) ; }
#define AQM0802A_WAIT40ms()			dly_tsk( 40 )					/*   40ms ȏ҂ */
#define AQM0802A_WAIT200ms()		dly_tsk( 200 )					/*  200ms ȏ҂ */


/* ---------------------------------------------------------------- */
/*   AT24Cxxxx                                                      */
/* ---------------------------------------------------------------- */
#define AT24C_LOCK()												/* bN     */
#define AT24C_UNLOCK()												/* bN */
#define AT24C_SEND					i2c_send						/* M   */
#define AT24C_RECV					i2c_recv						/* M   */
#define AT24C_XFER					i2c_xfer						/* ]   */


/* ---------------------------------------------------------------- */
/*   MCP3002                                                        */
/* ---------------------------------------------------------------- */
#define MCP3002_LOCK()												/* bN         */
#define MCP3002_UNLOCK()											/* bN     */
#define MCP3002_MODE( mode )		spi_mode( mode )				/* [hI */
#define MCP3002_XFER( value )		spi_xfer8( value )				/* ]       */
#define MCP3002_CS_LO()				IOB_0 = 0						/* CS pin Low     */
#define MCP3002_CS_HI()				IOB_0 = 1						/* CS pin High    */


/* ---------------------------------------------------------------- */
/*   MPL115A1                                                       */
/* ---------------------------------------------------------------- */
#define MPL115A1_LOCK()												/* bN                   */
#define MPL115A1_UNLOCK()											/* bN               */
#define MPL115A1_ADC_COUNT			16								/* A/D ϊ             */
#define MPL115A1_MODE( mode )		spi_mode( mode )				/* [hI           */
#define MPL115A1_XFER( value )		spi_xfer8( value )				/* ]                 */
#define MPL115A1_CS_LO()			IOD_6 = 0						/* CS pin Low               */
#define MPL115A1_CS_HI()			IOD_6 = 1						/* CS pin High              */
#define MPL115A1_WAIT3ms()			dly_tsk( 3 )					/* 3ms ȏ҂             */
#define MPL115A1_WAIT5ms()			dly_tsk( 5 )					/* 5ms ȏ҂             */
#define MPL115A1_SEG_ADC			__NEARI							/* A/D ϊlzuZOg */


/* ---------------------------------------------------------------- */
/*   SDC                                                            */
/* ---------------------------------------------------------------- */
#define SDC_LOCK()													/* bN         */
#define SDC_UNLOCK()												/* bN     */
#define SDC_MODE( mode )			spi_mode( mode )				/* [hI */
#define SDC_XFER( value )			spi_xfer8( value )				/* ]       */
#define SDC_CS_LO()					IOA_0 = 0						/* CS pin Low     */
#define SDC_CS_HI()					IOA_0 = 1						/* CS pin High    */


/* ---------------------------------------------------------------- */
/*   RSFAT                                                          */
/* ---------------------------------------------------------------- */
#define RSFAT_LOCK()												/* bN       */
#define RSFAT_UNLOCK()												/* bN   */
#define RSFAT_INIT()				sdc_reset()						/*    */
																	/* ǂݍݏ */
#define RSFAT_READ(sector, p_buff, count)	sdc_read(sector, p_buff, count)
#define RSFAT_WORK					__xdata __at (0xe000)			/* Ɨ̈     */


/* ---------------------------------------------------------------- */
/*   eXgAv                                                   */
/* ---------------------------------------------------------------- */
#define LED0( value )				IOB_0 = (value)
#define LED1( value )				IOB_1 = (value)
#define LED2( value )				IOB_2 = (value)
#define LED3( value )				IOB_3 = (value)


//#define getchar()					uart_read()
//#define putchar( c )				uart_write( c )


#endif/*__EZUSB_FX2__CONFIG_H__INCLUDED__*/
