/* ================================================================================ */
/*   ezusb_fx2/depend.c                                                             */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"
#include "mcp3002.h"
#include "mpl115a1.h"


/* -------------------------------------------------------------------------------- */
/*                                                                            */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void rtos_init( void )
{
	/* WX^ */
	MPAGE        = 0xe6 ;
	CPUCS        = (CPUCS & ~(CPUCS_CLKSPD1|CPUCS_CLKSPD0)) | CPUCS_CLKSPD1 ;
	CKCON        = CKCON_T2M | CKCON_T1M | CKCON_T0M ;
	AUTOPTRSETUP = AUTOPTRSETUP_APTR2INC | AUTOPTRSETUP_APTR1INC | AUTOPTRSETUP_APTREN ;

	/* |[gݒ */
#if     (PORTA_DIR != 0)
	OEA = PORTA_DIR ;
#endif/*(PORTA_DIR != 0)*/

#if     (PORTB_DIR != 0)
	OEB = PORTB_DIR ;
#endif/*(PORTB_DIR != 0)*/

#if     (PORTC_DIR != 0)
	OEC = PORTC_DIR ;
#endif/*(PORTC_DIR != 0)*/

#if     (PORTD_DIR != 0)
	OED = PORTD_DIR ;
#endif/*(PORTD_DIR != 0)*/

#if     (PORTE_DIR != 0)
	OEE = PORTE_DIR ;
#endif/*(PORTE_DIR != 0)*/

	/* hCo[ */
#ifdef  CONFIG_UART
	uart_init() ;
#endif/*CONFIG_UART*/

#ifdef  CONFIG_I2C
	i2c_init() ;
#endif/*CONFIG_UART*/

#ifdef  CONFIG_SDC
	sdc_init() ;
#endif/*CONFIG_SDC*/

#ifdef  CONFIG_MCP3002
	mcp3002_init() ;
#endif/*CONFIG_MCP3002*/

#ifdef  CONFIG_MPL115A1
	mpl115a1_init() ;
#endif/*CONFIG_MPL115A1*/
}


/* -------------------------------------------------------------------------------- */
/*   1us ҂                                                                       */
/*                                                                                  */
/*   IN : count = ҂                                                          */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void wait1us( uint16_t count ) __naked
{
	count = count ;

	__asm__(
	"	MOV		R0, DPH							\n"
	"	INC		R0								\n"
	"wait1us_100:								\n"
	"	; 10us = 12 = 4 + 4 + 4					\n"
	"	LJMP	wait1us_140			; 4 cycle	\n"
	"wait1us_140:								\n"
	"	LJMP	wait1us_180			; 4 cycle	\n"
	"wait1us_180:								\n"
	"	DJNZ	DPL, wait1us_100	; 4 cycle	\n"
	"	DJNZ	R0, wait1us_100					\n"
	"	RET										\n"
	) ;
}


/* -------------------------------------------------------------------------------- */
/*   10us ҂                                                                      */
/*                                                                                  */
/*   IN : count = ҂                                                          */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void wait10us( uint16_t count ) __naked
{
	count = count ;

	__asm__(
	"	MOV		R0, DPH							\n"
	"	INC		R0								\n"
	"wait10us_100:								\n"
	"	; 10us = 120 = 2 + (19 * 6) + 4			\n"
	"	MOV		R1, #19				; 2 cycle	\n"
	"wait10us_180:								\n"
	"	AJMP	wait10us_1c0		; 3 cycle	\n"
	"wait10us_1c0:								\n"
	"	DJNZ	R1, wait10us_180	; 3 cycle	\n"
	"	DJNZ	DPL, wait10us_100	; 4 cycle	\n"
	"	DJNZ	R0, wait10us_100				\n"
	"	RET										\n"
	) ;
}
