; ================================================================================ 
;   ezusb_fx2/kernel_cfg.asm                                                       
;                                                                                  
;   Copyright (C) 2014 lsluk, All rights reserved.                                 
;   http://www.geocities.jp/g_lsluk/index.html                                     
; ================================================================================ 

; ------------------------------------------------ 
;   J[lݒ                                   
; ------------------------------------------------ 
KERNEL_CFG_STKSZ	=	24				; J[l̃X^bNTCY
KERNEL_CFG_SIG_TIM	=	12000				; ^CeBbN̋ԁi1ms = 48000000 / 4 / 1000j
KERNEL_CFG_TSK_REG	=	8				; ^XÑWX^ۑ
KERNEL_CFG_TSK_PRI	=	4				; ^XNDx̍ől


; ------------------------------------------------ 
;   J[lRtBO}N                       
; ------------------------------------------------ 
DPL1			=	0x84
DPH1			=	0x85
DPS			=	0x86

	.macro	KERNEL_CFG_ISR_ENTER				; 荞݃T[rX[`
	PUSH	DPS
	MOV	DPS, #0x00
	.endm

	.macro	KERNEL_CFG_ISR_LEAVE				; 荞݃T[rX[`o
	POP	DPS
	.endm

	.macro	KERNEL_CFG_DSP_ENTER				; fBXpb`
	MOV	A, DPL1
	MOVX	@DPTR, A
	INC	DPTR
	MOV	A, DPH1
	MOVX	@DPTR, A
	INC	DPTR
	.endm

	.macro	KERNEL_CFG_DSP_LEAVE				; fBXpb`o
	MOVX	A, @DPTR
	MOV	DPL1, A
	INC	DPTR
	MOVX	A, @DPTR
	MOV	DPH1, A
	INC	DPTR
	.endm


; ------------------------------------------------ 
;   ^XN                                         
; ------------------------------------------------ 
CRE_TSK		0, _idle_tsk, KERNEL_CFG_TSK_PRI, 32		; ACh^XN
CRE_TSK		1, _main_tsk, 1,                  64		; C^XN
CRE_TSK		2, _sub_tsk,  2,                  64		; Tu^XN
CRE_TSK		3, _usb_tsk,  3,                  64		; USB ^XN


; ------------------------------------------------ 
;   Z}tH                                       
; ------------------------------------------------ 
CRE_SEM		1, 8, 8						; VAM
CRE_SEM		2, 0, 8						; VAM
CRE_SEM		3, 0, 1						; I2C 荞
CRE_SEM		4, 0, 1						; USB SETUP f[^荞
CRE_SEM		5, 1, 1						; eXgAvrp


; ------------------------------------------------ 
;   nh                                   
; ------------------------------------------------ 
CRE_CYC		1, TA_STA, _cychdr1,     100			; LED2 _
CRE_CYC		2, TA_STA, _cychdr2,    1000			; LED3 _
CRE_CYC		3, 0,      _usb_cychdr,  200			; USB eXgp


; ------------------------------------------------ 
;   荞݃nh                               
; ------------------------------------------------ 
DEF_INH		0x0003, 0					; INT0 O荞
DEF_INH		0x000b, 0					; ^C}O荞
DEF_INH		0x0013, 0					; INT1 O荞
DEF_INH		0x001b, 0					; ^C}P荞
DEF_INH		0x0023, 0					; USART0 荞
DEF_INH		0x002b, 1					; ^C}Q荞݁iJ[l\j
DEF_INH		0x0033, 0					; WAKEUP/WU2EW[荞
DEF_INH		0x003b, 0					; USART1 荞
DEF_INH		0x0043, 0, 0x0100				; USB 荞
DEF_INH		0x004b, 1, _i2c_isr				; I2C 荞
DEF_INH		0x0053, 0, 0x0080				; GPIF/FIFOs/INT4 O荞
DEF_INH		0x005b, 0					; INT5 O荞
DEF_INH		0x0063, 0					; INT6 O荞
								; FIFO/GPIF-Interrupt Jump Table
DEF_INH		0x0080, 0					;   Endpoint 2 Programmable Flag
DEF_INH		0x0084, 0					;   Endpoint 4 Programmable Flag
DEF_INH		0x0088, 0					;   Endpoint 6 Programmable Flag
DEF_INH		0x008c, 0					;   Endpoint 8 Programmable Flag
DEF_INH		0x0090, 0					;   Endpoint 2 Empty Flag
DEF_INH		0x0094, 0					;   Endpoint 4 Empty Flag
DEF_INH		0x0098, 0					;   Endpoint 6 Empty Flag
DEF_INH		0x009c, 0					;   Endpoint 8 Empty Flag
DEF_INH		0x00a0, 0					;   Endpoint 2 Full Flag
DEF_INH		0x00a4, 0					;   Endpoint 4 Full Flag
DEF_INH		0x00a8, 0					;   Endpoint 6 Full Flag
DEF_INH		0x00ac, 0					;   Endpoint 8 Full Flag
DEF_INH		0x00b0, 0					;   GPIF Operation Complete
DEF_INH		0x00b4, 0					;   GPIF Waveform
								; USB-Interrupt Jump Table
DEF_INH		0x0100, 1, _usb_isr_sudav			;   SETUP Data Available
DEF_INH		0x0104, 0, _usb_isr_sof				;   Start of Frame (or microframe)
DEF_INH		0x0108, 0, _usb_isr_sutok			;   Setup Token Received
DEF_INH		0x010c, 0, _usb_isr_suspend			;   USB Suspend request
DEF_INH		0x0110, 0, _usb_isr_usbreset			;   Bus reset
DEF_INH		0x0114, 0, _usb_isr_hispeed			;   Entered high speed operation
DEF_INH		0x0118, 0, _usb_isr_ep0ack			;   FX2 ACKfd the CONTROL Handshake
DEF_INH		0x011c, 0					;   reserved
DEF_INH		0x0120, 0, _usb_isr_ep0in			;   EP0-IN ready to be loaded with data
DEF_INH		0x0124, 0, _usb_isr_ep0out			;   EP0-OUT has USB data
DEF_INH		0x0128, 0, _usb_isr_ep1in			;   EP1-IN ready to be loaded with data
DEF_INH		0x012c, 0, _usb_isr_ep1out			;   EP1-OUT has USB data
DEF_INH		0x0130, 0, _usb_isr_ep2				;   IN: buffer available. OUT: buffer has data
DEF_INH		0x0134, 0, _usb_isr_ep4				;   IN: buffer available. OUT: buffer has data
DEF_INH		0x0138, 0, _usb_isr_ep6				;   IN: buffer available. OUT: buffer has data
DEF_INH		0x013c, 0, _usb_isr_ep8				;   IN: buffer available. OUT: buffer has data
DEF_INH		0x0140, 0, _usb_isr_idn				;   IN-Bulk-NAK (any IN endpoint)
DEF_INH		0x0144, 0					;   reserved
DEF_INH		0x0148, 0, _usb_isr_ep0ping			;   EP0 OUT was Pinged and it NAKfd
DEF_INH		0x014c, 0, _usb_isr_ep1ping			;   EP1 OUT was Pinged and it NAKfd
DEF_INH		0x0150, 0, _usb_isr_ep2ping			;   EP2 OUT was Pinged and it NAKfd
DEF_INH		0x0154, 0, _usb_isr_ep4ping			;   EP4 OUT was Pinged and it NAKfd
DEF_INH		0x0158, 0, _usb_isr_ep6ping			;   EP6 OUT was Pinged and it NAKfd
DEF_INH		0x015c, 0, _usb_isr_ep8ping			;   EP8 OUT was Pinged and it NAKfd
DEF_INH		0x0160, 0, _usb_isr_errlimit			;   Bus errors exceeded the programmed limit
DEF_INH		0x0164, 0					;   reserved
DEF_INH		0x0168, 0					;   reserved
DEF_INH		0x016c, 0					;   reserved
DEF_INH		0x0170, 0, _usb_isr_ep2isoerr			;   ISO EP2 OUT PID sequence error
DEF_INH		0x0174, 0, _usb_isr_ep4isoerr			;   ISO EP4 OUT PID sequence error
DEF_INH		0x0178, 0, _usb_isr_ep6isoerr			;   ISO EP6 OUT PID sequence error
DEF_INH		0x017c, 0, _usb_isr_ep8isoerr			;   ISO EP8 OUT PID sequence error
