/* ================================================================================ */
/*   ezusb_fx2/regs.h                                                               */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __EZUSB_FX2__REGS_H__INCLUDED__
#define __EZUSB_FX2__REGS_H__INCLUDED__

	/* PCON */
	enum {
		PCON_SMOD0					=	1 << 7,
		PCON_GF1					=	1 << 3,
		PCON_GF0					=	1 << 2,
		PCON_STOP					=	1 << 1,
		PCON_IDLE					=	1 << 0
	} ;

	/* CKCON */
	enum {
		CKCON_T2M					=	1 << 5,
		CKCON_T1M					=	1 << 4,
		CKCON_T0M					=	1 << 3,
		CKCON_MD2					=	1 << 2,
		CKCON_MD1					=	1 << 1,
		CKCON_MD0					=	1 << 0
	} ;

	/* EXIF */
	enum {
		EXIF_IE5					=	1 << 7,
		EXIF_IE4					=	1 << 6,
		EXIF_I2CINT					=	1 << 5,
		EXIF_USBINT					=	1 << 4
	} ;

	/* EP2468STAT */
	enum {
		EP2468STAT_EP8F				=	1 << 7,
		EP2468STAT_EP8E				=	1 << 6,
		EP2468STAT_EP6F				=	1 << 5,
		EP2468STAT_EP6E				=	1 << 4,
		EP2468STAT_EP4F				=	1 << 3,
		EP2468STAT_EP4E				=	1 << 2,
		EP2468STAT_EP2F				=	1 << 1,
		EP2468STAT_EP2E				=	1 << 0
	} ;

	/* EP24FIFOFLGS */
	enum {
		EP24FIFOFLGS_EP4PF			=	1 << 6,
		EP24FIFOFLGS_EP4EF			=	1 << 5,
		EP24FIFOFLGS_EP4FF			=	1 << 4,
		EP24FIFOFLGS_EP2PF			=	1 << 2,
		EP24FIFOFLGS_EP2EF			=	1 << 1,
		EP24FIFOFLGS_EP2FF			=	1 << 0
	} ;

	/* EP68FIFOFLGS */
	enum {
		EP68FIFOFLGS_EP8PF			=	1 << 6,
		EP68FIFOFLGS_EP8EF			=	1 << 5,
		EP68FIFOFLGS_EP8FF			=	1 << 4,
		EP68FIFOFLGS_EP6PF			=	1 << 2,
		EP68FIFOFLGS_EP6EF			=	1 << 1,
		EP68FIFOFLGS_EP6FF			=	1 << 0
	} ;

	/* AUTOPTRSETUP */
	enum {
		AUTOPTRSETUP_APTR2INC		=	1 << 2,
		AUTOPTRSETUP_APTR1INC		=	1 << 1,
		AUTOPTRSETUP_APTREN			=	1 << 0
	} ;

	/* EP01STAT */
	enum {
		EP01STAT_EP1INBSY			=	1 << 2,
		EP01STAT_EP1OUTBSY			=	1 << 1,
		EP01STAT_EP0BSY				=	1 << 0
	} ;

	/* GPIFTRIG */
	enum {
		GPIFTRIG_DONE				=	1 << 7,
		GPIFTRIG_RW					=	1 << 2,
		GPIFTRIG_EP1				=	1 << 1,
		GPIFTRIG_EP0				=	1 << 0
	} ;


__sfr           __at (0x80)			IOA ;
	__sbit      __at (0x80)			IOA_0 ;
	__sbit      __at (0x81)			IOA_1 ;
	__sbit      __at (0x82)			IOA_2 ;
	__sbit      __at (0x83)			IOA_3 ;
	__sbit      __at (0x84)			IOA_4 ;
	__sbit      __at (0x85)			IOA_5 ;
	__sbit      __at (0x86)			IOA_6 ;
	__sbit      __at (0x87)			IOA_7 ;
__sfr           __at (0x82)			DPL0 ;
__sfr           __at (0x83)			DPH0 ;
__sfr           __at (0x84)			DPL1 ;
__sfr           __at (0x85)			DPH1 ;
__sfr           __at (0x86)			DPS ;
__sfr           __at (0x8e)			CKCON ;
__sfr           __at (0x90)			IOB ;
	__sbit      __at (0x90)			IOB_0 ;
	__sbit      __at (0x91)			IOB_1 ;
	__sbit      __at (0x92)			IOB_2 ;
	__sbit      __at (0x93)			IOB_3 ;
	__sbit      __at (0x94)			IOB_4 ;
	__sbit      __at (0x95)			IOB_5 ;
	__sbit      __at (0x96)			IOB_6 ;
	__sbit      __at (0x97)			IOB_7 ;
__sfr           __at (0x91)			EXIF ;
__sfr           __at (0x92)			MPAGE ;
__sfr           __at (0x98)			SCON0 ;
	__sbit      __at (0x98)			SM0_0 ;
	__sbit      __at (0x99)			SM1_0 ;
	__sbit      __at (0x9a)			SM2_0 ;
	__sbit      __at (0x9b)			REN_0 ;
	__sbit      __at (0x9c)			TB8_0 ;
	__sbit      __at (0x9d)			RB8_0 ;
	__sbit      __at (0x9e)			TI_0 ;
	__sbit      __at (0x9f)			RI_0 ;
__sfr           __at (0x99)			SBUF0 ;
__sfr           __at (0x9a)			AUTOPTRH1 ;
__sfr           __at (0x9b)			AUTOPTRL1 ;
__sfr           __at (0x9d)			AUTOPTRH2 ;
__sfr           __at (0x9e)			AUTOPTRL2 ;
__sfr           __at (0xa0)			IOC ;
	__sbit      __at (0xa0)			IOC_0 ;
	__sbit      __at (0xa1)			IOC_1 ;
	__sbit      __at (0xa2)			IOC_2 ;
	__sbit      __at (0xa3)			IOC_3 ;
	__sbit      __at (0xa4)			IOC_4 ;
	__sbit      __at (0xa5)			IOC_5 ;
	__sbit      __at (0xa6)			IOC_6 ;
	__sbit      __at (0xa7)			IOC_7 ;
__sfr           __at (0xa1)			INT2CLR ;
__sfr           __at (0xa2)			INT4CLR ;
__sfr           __at (0xaa)			EP2468STAT ;
__sfr           __at (0xab)			EP24FIFOFLGS ;
__sfr           __at (0xac)			EP68FIFOFLGS ;
__sfr           __at (0xaf)			AUTOPTRSETUP ;
__sfr           __at (0xb0)			IOD ;
	__sbit      __at (0xb0)			IOD_0 ;
	__sbit      __at (0xb1)			IOD_1 ;
	__sbit      __at (0xb2)			IOD_2 ;
	__sbit      __at (0xb3)			IOD_3 ;
	__sbit      __at (0xb4)			IOD_4 ;
	__sbit      __at (0xb5)			IOD_5 ;
	__sbit      __at (0xb6)			IOD_6 ;
	__sbit      __at (0xb7)			IOD_7 ;
__sfr           __at (0xb1)			IOE ;
__sfr           __at (0xb2)			OEA ;
__sfr           __at (0xb3)			OEB ;
__sfr           __at (0xb4)			OEC ;
__sfr           __at (0xb5)			OED ;
__sfr           __at (0xb6)			OEE ;
__sfr           __at (0xba)			EP01STAT ;
__sfr           __at (0xbb)			GPIFTRIG ;
__sfr           __at (0xbd)			GPIFSGLDATH ;
__sfr           __at (0xbe)			GPIFSGLDATLX ;
__sfr           __at (0xbf)			GPIFSGLDATLNOX ;
__sfr           __at (0xc0)			SCON1 ;
	__sbit      __at (0xc0)			SM0_1 ;
	__sbit      __at (0xc1)			SM1_1 ;
	__sbit      __at (0xc2)			SM2_1 ;
	__sbit      __at (0xc3)			REN_1 ;
	__sbit      __at (0xc4)			TB8_1 ;
	__sbit      __at (0xc5)			RB8_1 ;
	__sbit      __at (0xc6)			TI_1 ;
	__sbit      __at (0xc7)			RI_1 ;
__sfr           __at (0xc1)			SBUF1 ;
//#__sfr           __at (0xd0)			PSW ;
	__sbit      __at (0xd1)			F1 ;
	__sbit      __at (0xd5)			F0 ;
__sfr           __at (0xd8)			EICON ;
	__sbit      __at (0xdb)			INT6 ;
	__sbit      __at (0xdc)			RESI ;
	__sbit      __at (0xdd)			ERESI ;
	__sbit      __at (0xdf)			SMOD1 ;
//#__sfr           __at (0xe0)			ACC ;
	__sbit      __at (0xe0)			ACC_0 ;
	__sbit      __at (0xe1)			ACC_1 ;
	__sbit      __at (0xe2)			ACC_2 ;
	__sbit      __at (0xe3)			ACC_3 ;
	__sbit      __at (0xe4)			ACC_4 ;
	__sbit      __at (0xe5)			ACC_5 ;
	__sbit      __at (0xe6)			ACC_6 ;
	__sbit      __at (0xe7)			ACC_7 ;
__sfr           __at (0xe8)			EIE ;
	__sbit      __at (0xe8)			EUSB ;
	__sbit      __at (0xe9)			EI2C ;
	__sbit      __at (0xea)			EX4 ;
	__sbit      __at (0xeb)			EX5 ;
	__sbit      __at (0xec)			EX6 ;
//#__sfr           __at (0xf0)			B ;
	__sbit      __at (0xf0)			B_0 ;
	__sbit      __at (0xf1)			B_1 ;
	__sbit      __at (0xf2)			B_2 ;
	__sbit      __at (0xf3)			B_3 ;
	__sbit      __at (0xf4)			B_4 ;
	__sbit      __at (0xf5)			B_5 ;
	__sbit      __at (0xf6)			B_6 ;
	__sbit      __at (0xf7)			B_7 ;
__sfr           __at (0xf8)			EIP ;
	__sbit      __at (0xf8)			PUSB ;
	__sbit      __at (0xf9)			PI2C ;
	__sbit      __at (0xfa)			PX4 ;
	__sbit      __at (0xfb)			PX5 ;
	__sbit      __at (0xfc)			PX6 ;

	/* CPUCS */
	enum {
		CPUCS_PORTCSTB				=	1 << 5,
		CPUCS_CLKSPD1				=	1 << 4,
		CPUCS_CLKSPD0				=	1 << 3,
		CPUCS_CLKINV				=	1 << 2,
		CPUCS_CLKOE					=	1 << 1,
		CPUCS_8051RES				=	1 << 0
	} ;

	/* IFCONFIG */
	enum {
		IFCONFIG_IFCLKSRC			=	1 << 7,
		IFCONFIG_3048MHZ			=	1 << 6,
		IFCONFIG_IFCLKOE			=	1 << 5,
		IFCONFIG_IFCLKPOL			=	1 << 4,
		IFCONFIG_ASYNC				=	1 << 3,
		IFCONFIG_GSTATE				=	1 << 2,
		IFCONFIG_IFCFG1				=	1 << 1,
		IFCONFIG_IFCFG0				=	1 << 0
	} ;

	/* PINFLAGSCD */
	enum {
		PINFLAGSAB_FLAGB3			=	1 << 7,
		PINFLAGSAB_FLAGB2			=	1 << 6,
		PINFLAGSAB_FLAGB1			=	1 << 5,
		PINFLAGSAB_FLAGB0			=	1 << 4,
		PINFLAGSAB_FLAGA3			=	1 << 3,
		PINFLAGSAB_FLAGA2			=	1 << 2,
		PINFLAGSAB_FLAGA1			=	1 << 1,
		PINFLAGSAB_FLAGA0			=	1 << 0
	} ;

	/* PINFLAGSAB */
	enum {
		PINFLAGSCD_FLAGD3			=	1 << 7,
		PINFLAGSCD_FLAGD2			=	1 << 6,
		PINFLAGSCD_FLAGD1			=	1 << 5,
		PINFLAGSCD_FLAGD0			=	1 << 4,
		PINFLAGSCD_FLAGC3			=	1 << 3,
		PINFLAGSCD_FLAGC2			=	1 << 2,
		PINFLAGSCD_FLAGC1			=	1 << 1,
		PINFLAGSCD_FLAGC0			=	1 << 0
	} ;

	/* FIFORESET */
	enum {
		FIFORESET_NAKALL			=	1 << 7,
		FIFORESET_EP3				=	1 << 3,
		FIFORESET_EP2				=	1 << 2,
		FIFORESET_EP1				=	1 << 1,
		FIFORESET_EP0				=	1 << 0
	} ;

	/* BREAKPT */
	enum {
		BREAKPT_BREAK				=	1 << 3,
		BREAKPT_BPPULSE				=	1 << 2,
		BREAKPT_BPEN				=	1 << 1
	} ;

	/* UART230 */
	enum {
		UART230_230UART1			=	1 << 1,
		UART230_230UART0			=	1 << 0
	} ;

	/* FIFOPINPOLAR */
	enum {
		FIFOPINPOLAR_PKTEND			=	1 << 5,
		FIFOPINPOLAR_SLOE			=	1 << 4,
		FIFOPINPOLAR_SLRD			=	1 << 3,
		FIFOPINPOLAR_SLWR			=	1 << 2,
		FIFOPINPOLAR_EF				=	1 << 1,
		FIFOPINPOLAR_FF				=	1 << 0
	} ;

	/* GPIFHOLDTIME */
	enum {
		GPIFHOLDTIME_HOLDTIME1		=	1 << 1,
		GPIFHOLDTIME_HOLDTIME0		=	1 << 0
	} ;

	enum {
		EPnCFG_VALID_				=	7,
		EPnCFG_DIR_					=	6,
		EPnCFG_TYPE1_				=	5,
		EPnCFG_TYPE0_				=	4,
		EPnCFG_SIZE_				=	3,
		EPnCFG_BUF1_				=	1,
		EPnCFG_BUF0_				=	0
	} ;

	/* EP1OUTCFG */
	enum {
		EP1OUTCFG_VALID_DEACTIVE	=	0 << EPnCFG_VALID_,
		EP1OUTCFG_VALID_ACTIVE		=	1 << EPnCFG_VALID_,
		EP1OUTCFG_TYPE_BULK			=	2 << EPnCFG_TYPE0_,
		EP1OUTCFG_TYPE_INTERRUPT	=	3 << EPnCFG_TYPE0_
	} ;

	/* EP1INCFG */
	enum {
		EP1INCFG_VALID_DEACTIVE		=	0 << EPnCFG_VALID_,
		EP1INCFG_VALID_ACTIVE		=	1 << EPnCFG_VALID_,
		EP1INCFG_TYPE_BULK			=	2 << EPnCFG_TYPE0_,
		EP1INCFG_TYPE_INTERRUPT		=	3 << EPnCFG_TYPE0_
	} ;

	/* EP2CFG */
	enum {
		EP2CFG_VALID_DEACTIVE		=	0 << EPnCFG_VALID_,
		EP2CFG_VALID_ACTIVE			=	1 << EPnCFG_VALID_,
		EP2CFG_DIR_OUT				=	0 << EPnCFG_DIR_,
		EP2CFG_DIR_IN				=	1 << EPnCFG_DIR_,
		EP2CFG_TYPE_ISOCHRONOUS		=	1 << EPnCFG_TYPE0_,
		EP2CFG_TYPE_BULK			=	2 << EPnCFG_TYPE0_,
		EP2CFG_TYPE_INTERRUPT		=	3 << EPnCFG_TYPE0_,
		EP2CFG_SIZE_512				=	0 << EPnCFG_SIZE_,,
		EP2CFG_SIZE_1024			=	1 << EPnCFG_SIZE_,
		EP2CFG_BUF_QUAD				=	0 << EPnCFG_BUF0_,
		EP2CFG_BUF_DOUBLE			=	2 << EPnCFG_BUF0_,
		EP2CFG_BUF_TRIPLE			=	3 << EPnCFG_BUF0_
	} ;

	/* EP4CFG */
	enum {
		EP4CFG_VALID_DEACTIVE		=	0 << EPnCFG_VALID_,
		EP4CFG_VALID_ACTIVE			=	1 << EPnCFG_VALID_,
		EP4CFG_DIR_OUT				=	0 << EPnCFG_DIR_,
		EP4CFG_DIR_IN				=	1 << EPnCFG_DIR_,
		EP4CFG_TYPE_ISOCHRONOUS		=	1 << EPnCFG_TYPE0_,
		EP4CFG_TYPE_BULK			=	2 << EPnCFG_TYPE0_,
		EP4CFG_TYPE_INTERRUPT		=	3 << EPnCFG_TYPE0_,
	} ;

	/* EP6CFG */
	enum {
		EP6CFG_VALID_DEACTIVE		=	0 << EPnCFG_VALID_,
		EP6CFG_VALID_ACTIVE			=	1 << EPnCFG_VALID_,
		EP6CFG_DIR_OUT				=	0 << EPnCFG_DIR_,
		EP6CFG_DIR_IN				=	1 << EPnCFG_DIR_,
		EP6CFG_TYPE_ISOCHRONOUS		=	1 << EPnCFG_TYPE0_,
		EP6CFG_TYPE_BULK			=	2 << EPnCFG_TYPE0_,
		EP6CFG_TYPE_INTERRUPT		=	3 << EPnCFG_TYPE0_,
		EP6CFG_SIZE_512				=	0 << EPnCFG_SIZE_,,
		EP6CFG_SIZE_1024			=	1 << EPnCFG_SIZE_,
		EP6CFG_BUF_QUAD				=	0 << EPnCFG_BUF0_,
		EP6CFG_BUF_DOUBLE			=	2 << EPnCFG_BUF0_,
		EP6CFG_BUF_TRIPLE			=	3 << EPnCFG_BUF0_
	} ;

	/* EP8CFG */
	enum {
		EP8CFG_VALID_DEACTIVE		=	0 << EPnCFG_VALID_,
		EP8CFG_VALID_ACTIVE			=	1 << EPnCFG_VALID_,
		EP8CFG_DIR_OUT				=	0 << EPnCFG_DIR_,
		EP8CFG_DIR_IN				=	1 << EPnCFG_DIR_,
		EP8CFG_TYPE_ISOCHRONOUS		=	1 << EPnCFG_TYPE0_,
		EP8CFG_TYPE_BULK			=	2 << EPnCFG_TYPE0_,
		EP8CFG_TYPE_INTERRUPT		=	3 << EPnCFG_TYPE0_,
	} ;

	/* EP2FIFOCFG */
	enum {
		EP2FIFOCFG_INFM1			=	1 << 6,
		EP2FIFOCFG_OEP1				=	1 << 5,
		EP2FIFOCFG_AUTOOUT			=	1 << 4,
		EP2FIFOCFG_AUTOIN			=	1 << 3,
		EP2FIFOCFG_ZEROLENIN		=	1 << 2,
		EP2FIFOCFG_WORDWIDE			=	1 << 0
	} ;

	/* EP4FIFOCFG */
	enum {
		EP4FIFOCFG_INFM1			=	1 << 6,
		EP4FIFOCFG_OEP1				=	1 << 5,
		EP4FIFOCFG_AUTOOUT			=	1 << 4,
		EP4FIFOCFG_AUTOIN			=	1 << 3,
		EP4FIFOCFG_ZEROLENIN		=	1 << 2,
		EP4FIFOCFG_WORDWIDE			=	1 << 0
	} ;

	/* EP6FIFOCFG */
	enum {
		EP6FIFOCFG_INFM1			=	1 << 6,
		EP6FIFOCFG_OEP1				=	1 << 5,
		EP6FIFOCFG_AUTOOUT			=	1 << 4,
		EP6FIFOCFG_AUTOIN			=	1 << 3,
		EP6FIFOCFG_ZEROLENIN		=	1 << 2,
		EP6FIFOCFG_WORDWIDE			=	1 << 0
	} ;

	/* EP8FIFOCFG */
	enum {
		EP8FIFOCFG_INFM1			=	1 << 6,
		EP8FIFOCFG_OEP1				=	1 << 5,
		EP8FIFOCFG_AUTOOUT			=	1 << 4,
		EP8FIFOCFG_AUTOIN			=	1 << 3,
		EP8FIFOCFG_ZEROLENIN		=	1 << 2,
		EP8FIFOCFG_WORDWIDE			=	1 << 0
	} ;

//#	EP2FIFOPFH
//#	EP2FIFOPFL
//#	EP4FIFOPFH
//#	EP4FIFOPFL
//#	EP6FIFOPFH
//#	EP6FIFOPFL
//#	EP8FIFOPFH
//#	EP8FIFOPFL

	/* EP2ISOINPKTS */
	enum {
		EP2ISOINPKTS_INPPF1			=	1 << 1,
		EP2ISOINPKTS_INPPF0			=	1 << 0
	} ;

	/* EP4ISOINPKTS */
	enum {
		EP4ISOINPKTS_INPPF1			=	1 << 1,
		EP4ISOINPKTS_INPPF0			=	1 << 0
	} ;

	/* EP6ISOINPKTS */
	enum {
		EP6ISOINPKTS_INPPF1			=	1 << 1,
		EP6ISOINPKTS_INPPF0			=	1 << 0
	} ;

	/* EP8ISOINPKTS */
	enum {
		EP8ISOINPKTS_INPPF1			=	1 << 1,
		EP8ISOINPKTS_INPPF0			=	1 << 0
	} ;

	/* INPKTEND */
	enum {
		INPKTEND_SKIP				=	1 << 7,
		INPKTEND_EP3				=	1 << 3,
		INPKTEND_EP2				=	1 << 2,
		INPKTEND_EP1				=	1 << 1,
		INPKTEND_EP0				=	1 << 0
	} ;

	/* OUTPKTEND */
	enum {
		OUTPKTEND_SKIP				=	1 << 7,
		OUTPKTEND_EP3				=	1 << 3,
		OUTPKTEND_EP2				=	1 << 2,
		OUTPKTEND_EP1				=	1 << 1,
		OUTPKTEND_EP0				=	1 << 0
	} ;

	/* EP2FIFOIE */
	enum {
		EP2FIFOIE_EDGEPF			=	1 << 3,
		EP2FIFOIE_PF				=	1 << 2,
		EP2FIFOIE_EF				=	1 << 1,
		EP2FIFOIE_FF				=	1 << 0
	} ;

	/* EP2FIFOIRQ */
	enum {
		EP2FIFOIRQ_PF				=	1 << 2,
		EP2FIFOIRQ_EF				=	1 << 1,
		EP2FIFOIRQ_FF				=	1 << 0
	} ;

	/* EP4FIFOIE */
	enum {
		EP4FIFOIE_EDGEPF			=	1 << 3,
		EP4FIFOIE_PF				=	1 << 2,
		EP4FIFOIE_EF				=	1 << 1,
		EP4FIFOIE_FF				=	1 << 0
	} ;

	/* EP4FIFOIRQ */
	enum {
		EP4FIFOIRQ_PF				=	1 << 2,
		EP4FIFOIRQ_EF				=	1 << 1,
		EP4FIFOIRQ_FF				=	1 << 0
	} ;

	/* EP6FIFOIE */
	enum {
		EP6FIFOIE_EDGEPF			=	1 << 3,
		EP6FIFOIE_PF				=	1 << 2,
		EP6FIFOIE_EF				=	1 << 1,
		EP6FIFOIE_FF				=	1 << 0
	} ;

	/* EP6FIFOIRQ */
	enum {
		EP6FIFOIRQ_PF				=	1 << 2,
		EP6FIFOIRQ_EF				=	1 << 1,
		EP6FIFOIRQ_FF				=	1 << 0
	} ;

	/* EP8FIFOIE */
	enum {
		EP8FIFOIE_EDGEPF			=	1 << 3,
		EP8FIFOIE_PF				=	1 << 2,
		EP8FIFOIE_EF				=	1 << 1,
		EP8FIFOIE_FF				=	1 << 0
	} ;

	/* EP8FIFOIRQ */
	enum {
		EP8FIFOIRQ_PF				=	1 << 2,
		EP8FIFOIRQ_EF				=	1 << 1,
		EP8FIFOIRQ_FF				=	1 << 0
	} ;

	/* IBNIE */
	enum {
		IBNIE_EP8					=	1 << 5,
		IBNIE_EP6					=	1 << 4,
		IBNIE_EP4					=	1 << 3,
		IBNIE_EP2					=	1 << 2,
		IBNIE_EP1					=	1 << 1,
		IBNIE_EP0					=	1 << 0
	} ;

	/* IBNIRQ */
	enum {
		IBNIRQ_EP8					=	1 << 5,
		IBNIRQ_EP6					=	1 << 4,
		IBNIRQ_EP4					=	1 << 3,
		IBNIRQ_EP2					=	1 << 2,
		IBNIRQ_EP1					=	1 << 1,
		IBNIRQ_EP0					=	1 << 0
	} ;

	/* NAKIE */
	enum {
		NAKIE_EP8					=	1 << 7,
		NAKIE_EP6					=	1 << 6,
		NAKIE_EP4					=	1 << 5,
		NAKIE_EP2					=	1 << 4,
		NAKIE_EP1					=	1 << 3,
		NAKIE_EP0					=	1 << 2,
		NAKIE_IBN					=	1 << 0
	} ;

	/* NAKIRQ */
	enum {
		NAKIRQ_EP8					=	1 << 7,
		NAKIRQ_EP6					=	1 << 6,
		NAKIRQ_EP4					=	1 << 5,
		NAKIRQ_EP2					=	1 << 4,
		NAKIRQ_EP1					=	1 << 3,
		NAKIRQ_EP0					=	1 << 2,
		NAKIRQ_IBN					=	1 << 0
	} ;

	/* USBIE */
	enum {
		USBIE_EP0ACK				=	1 << 6,
		USBIE_HSGRANT				=	1 << 5,
		USBIE_URES					=	1 << 4,
		USBIE_SUSP					=	1 << 3,
		USBIE_SUTOK					=	1 << 2,
		USBIE_SOF					=	1 << 1,
		USBIE_SUDAV					=	1 << 0
	} ;

	/* USBIRQ */
	enum {
		USBIRQ_EP0ACK				=	1 << 6,
		USBIRQ_HSGRANT				=	1 << 5,
		USBIRQ_URES					=	1 << 4,
		USBIRQ_SUSP					=	1 << 3,
		USBIRQ_SUTOK				=	1 << 2,
		USBIRQ_SOF					=	1 << 1,
		USBIRQ_SUDAV				=	1 << 0
	} ;

	/* EPIE */
	enum {
		EPIE_EP8					=	1 << 7,
		EPIE_EP6					=	1 << 6,
		EPIE_EP4					=	1 << 5,
		EPIE_EP2					=	1 << 4,
		EPIE_EP1OUT					=	1 << 3,
		EPIE_EP1IN					=	1 << 2,
		EPIE_EP0OUT					=	1 << 1,
		EPIE_EP0IN					=	1 << 0
	} ;

	/* EPIRQ */
	enum {
		EPIRQ_EP8					=	1 << 7,
		EPIRQ_EP6					=	1 << 6,
		EPIRQ_EP4					=	1 << 5,
		EPIRQ_EP2					=	1 << 4,
		EPIRQ_EP1OUT				=	1 << 3,
		EPIRQ_EP1IN					=	1 << 2,
		EPIRQ_EP0OUT				=	1 << 1,
		EPIRQ_EP0IN					=	1 << 0
	} ;

	/* GPIFIE */
	enum {
		GPIFIE_GPIFWF				=	1 << 1,
		GPIFIE_GPIFDONE				=	1 << 0
	} ;

	/* GPIFIRQ */
	enum {
		GPIFIRQ_GPIFWF				=	1 << 1,
		GPIFIRQ_GPIFDONE			=	1 << 0
	} ;

	/* USBERRIE */
	enum {
		USBERRIE_ISOEP8				=	1 << 7,
		USBERRIE_ISOEP6				=	1 << 6,
		USBERRIE_ISOEP4				=	1 << 5,
		USBERRIE_ISOEP2				=	1 << 4,
		USBERRIE_ERRLIMIT			=	1 << 0
	} ;

	/* USBERRIRQ */
	enum {
		USBERRIRQ_ISOEP8			=	1 << 7,
		USBERRIRQ_ISOEP6			=	1 << 6,
		USBERRIRQ_ISOEP4			=	1 << 5,
		USBERRIRQ_ISOEP2			=	1 << 4,
		USBERRIRQ_ERRLIMIT			=	1 << 0
	} ;

	/* ERRCNTLIM */
	enum {
		ERRCNTLIM_EC3				=	1 << 7,
		ERRCNTLIM_EC2				=	1 << 6,
		ERRCNTLIM_EC1				=	1 << 5,
		ERRCNTLIM_EC0				=	1 << 4,
		ERRCNTLIM_LIMIT3			=	1 << 3,
		ERRCNTLIM_LIMIT2			=	1 << 2,
		ERRCNTLIM_LIMIT1			=	1 << 1,
		ERRCNTLIM_LIMIT0			=	1 << 0
	} ;

	/* INTSETUP */
	enum {
		INTSETUP_AV2EN				=	1 << 3,
		INTSETUP_INT4SRC			=	1 << 1,
		INTSETUP_AV4EN				=	1 << 0
	} ;

	/* PORTACFG */
	enum {
		PORTACFG_FLAGD				=	1 << 7,
		PORTACFG_SLCS				=	1 << 6,
		PORTACFG_INT1				=	1 << 1,
		PORTACFG_INT0				=	1 << 0
	} ;

	/* PORTCCFG */
	enum {
		PORTCCFG_GPIFA7				=	1 << 7,
		PORTCCFG_GPIFA6				=	1 << 6,
		PORTCCFG_GPIFA5				=	1 << 5,
		PORTCCFG_GPIFA4				=	1 << 4,
		PORTCCFG_GPIFA3				=	1 << 3,
		PORTCCFG_GPIFA2				=	1 << 2,
		PORTCCFG_GPIFA1				=	1 << 1,
		PORTCCFG_GPIFA0				=	1 << 0
	} ;

	/* PORTECFG */
	enum {
		PORTECFG_GPIFA8				=	1 << 7,
		PORTECFG_T2EX				=	1 << 6,
		PORTECFG_INT6				=	1 << 5,
		PORTECFG_RXD1OUT			=	1 << 4,
		PORTECFG_RXD0OUT			=	1 << 3,
		PORTECFG_T2OUT				=	1 << 2,
		PORTECFG_T1OUT				=	1 << 1,
		PORTECFG_T0OUT				=	1 << 0
	} ;

	/* I2CS */
	enum {
		I2CS_START					=	1 << 7,
		I2CS_STOP					=	1 << 6,
		I2CS_LASTRD					=	1 << 5,
		I2CS_ID1					=	1 << 4,
		I2CS_ID0					=	1 << 3,
		I2CS_BERR					=	1 << 2,
		I2CS_ACK					=	1 << 1,
		I2CS_DONE					=	1 << 0
	} ;

	/* I2CTL */
	enum {
		I2CTL_STOPIE				=	1 << 1,
		I2CTL_400KHZ				=	1 << 0
	} ;

	/* USBCS */
	enum {
		USBCS_HSM					=	1 << 7,
		USBCS_DISCON				=	1 << 3,
		USBCS_NOSYNSOF				=	1 << 2,
		USBCS_RENUM					=	1 << 1,
		USBCS_SIGRSUME				=	1 << 0
	} ;

	/* WAKEUPCS */
	enum {
		WAKEUPCS_WU2				=	1 << 7,
		WAKEUPCS_WU					=	1 << 6,
		WAKEUPCS_WU2POL				=	1 << 5,
		WAKEUPCS_WUPOL				=	1 << 4,
		WAKEUPCS_DPEN				=	1 << 2,
		WAKEUPCS_WU2EN				=	1 << 1,
		WAKEUPCS_WUEN				=	1 << 0
	} ;

	/* TOGCTL */
	enum {
		TOGCTL_Q					=	1 << 7,
		TOGCTL_S					=	1 << 6,
		TOGCTL_R					=	1 << 5,
		TOGCTL_IO					=	1 << 4,
		TOGCTL_EP3					=	1 << 3,
		TOGCTL_EP2					=	1 << 2,
		TOGCTL_EP1					=	1 << 1,
		TOGCTL_EP0					=	1 << 0
	} ;

	enum {
		EPnCS_BUSY					=	1 << 1,
		EPnCS_STALL					=	1 << 0
	} ;

	/* EP0CS */
	enum {
		EP0CS_HSNAK					=	1 << 7,
		EP0CS_BUSY					=	EPnCS_BUSY,
		EP0CS_STALL					=	EPnCS_STALL
	} ;

	/* EP1OUTCS */
	enum {
		EP1OUTCS_BUSY				=	EPnCS_BUSY,
		EP1OUTCS_STALL				=	EPnCS_STALL
	} ;

	/* EP1INCS */
	enum {
		EP1INCS_BUSY				=	EPnCS_BUSY,
		EP1INCS_STALL				=	EPnCS_STALL
	} ;

	/* EP2CS */
	enum {
		EP2CS_NPAK2					=	1 << 6,
		EP2CS_NPAK1					=	1 << 5,
		EP2CS_NPAK0					=	1 << 4,
		EP2CS_FULL					=	1 << 3,
		EP2CS_EMPTY					=	1 << 2,
		EP2CS_STALL					=	EPnCS_STALL
	} ;

	/* EP4CS */
	enum {
		EP4CS_NPAK1					=	1 << 5,
		EP4CS_NPAK0					=	1 << 4,
		EP4CS_FULL					=	1 << 3,
		EP4CS_EMPTY					=	1 << 2,
		EP4CS_STALL					=	EPnCS_STALL
	} ;

	/* EP6CS */
	enum {
		EP6CS_NPAK2					=	1 << 6,
		EP6CS_NPAK1					=	1 << 5,
		EP6CS_NPAK0					=	1 << 4,
		EP6CS_FULL					=	1 << 3,
		EP6CS_EMPTY					=	1 << 2,
		EP6CS_STALL					=	EPnCS_STALL
	} ;

	/* EP8CS */
	enum {
		EP8CS_NPAK1					=	1 << 5,
		EP8CS_NPAK0					=	1 << 4,
		EP8CS_FULL					=	1 << 3,
		EP8CS_EMPTY					=	1 << 2,
		EP8CS_STALL					=	EPnCS_STALL
	} ;

	/* EP2FIFOFLGS */
	enum {
		EP2FIFOFLGS_PF				=	1 << 2,
		EP2FIFOFLGS_EF				=	1 << 1,
		EP2FIFOFLGS_FF				=	1 << 0
	} ;

	/* EP4FIFOFLGS */
	enum {
		EP4FIFOFLGS_PF				=	1 << 2,
		EP4FIFOFLGS_EF				=	1 << 1,
		EP4FIFOFLGS_FF				=	1 << 0
	} ;

	/* EP6FIFOFLGS */
	enum {
		EP6FIFOFLGS_PF				=	1 << 2,
		EP6FIFOFLGS_EF				=	1 << 1,
		EP6FIFOFLGS_FF				=	1 << 0
	} ;

	/* EP8FIFOFLGS */
	enum {
		EP8FIFOFLGS_PF				=	1 << 2,
		EP8FIFOFLGS_EF				=	1 << 1,
		EP8FIFOFLGS_FF				=	1 << 0
	} ;

	/* SUDPTRCTL */
	enum {
		SUDPTRCTL_SDPAUTO			=	1 << 0
	} ;

	/* GPIFWFSELECT */
	enum {
		GPIFWFSELECT_SINGLEWR1		=	1 << 7,
		GPIFWFSELECT_SINGLEWR0		=	1 << 6,
		GPIFWFSELECT_SINGLERD1		=	1 << 5,
		GPIFWFSELECT_SINGLERD0		=	1 << 4,
		GPIFWFSELECT_FIFOWR1		=	1 << 3,
		GPIFWFSELECT_FIFOWR0		=	1 << 2,
		GPIFWFSELECT_FIFORD1		=	1 << 1,
		GPIFWFSELECT_FIFORD0		=	1 << 0
	} ;

	/* GPIFIDLECS */
	enum {
		GPIFIDLECS_DONE				=	1 << 7,
		GPIFIDLECS_IDLEDRV			=	1 << 0
	} ;

	/* GPIFCTLCFG */
	enum {
		GPIFCTLCFG_TRICTL			=	1 << 7
	} ;

	/* EP2GPIFPFSTOP */
	enum {
		EP2GPIFPFSTOP_FIFO2FLAG		=	1 << 0
	} ;

	/* EP4GPIFPFSTOP */
	enum {
		EP4GPIFPFSTOP_FIFO4FLAG		=	1 << 0
	} ;

	/* EP6GPIFPFSTOP */
	enum {
		EP6GPIFPFSTOP_FIFO6FLAG		=	1 << 0
	} ;

	/* EP8GPIFPFSTOP */
	enum {
		EP8GPIFPFSTOP_FIFO8FLAG		=	1 << 0
	} ;

	/* GPIFREADYCFG */
	enum {
		GPIFREADYCFG_INTRDY			=	1 << 7,
		GPIFREADYCFG_SAS			=	1 << 6,
		GPIFREADYCFG_TCXRDY5		=	1 << 5
	} ;

/* 8051 xdata RAMiFX2LP onlyj */
volatile __xdata __at (0xe000) uint8_t		XRAM[512] ;

/* GPIF Waveform Memories */
volatile __xdata __at (0xe400) uint8_t		WAVEDATA[128] ;

/* GENERAL CONFIGURATION */
volatile __pdata __at (0xe600) uint8_t		CPUCS ;
volatile __pdata __at (0xe601) uint8_t		IFCONFIG ;
volatile __pdata __at (0xe602) uint8_t		PINFLAGSAB ;
volatile __pdata __at (0xe603) uint8_t		PINFLAGSCD ;
volatile __pdata __at (0xe604) uint8_t		FIFORESET ;
volatile __pdata __at (0xe605) uint8_t		BREAKPT ;
volatile __pdata __at (0xe606) uint8_t		BPADDRH ;
volatile __pdata __at (0xe607) uint8_t		BPADDRL ;
volatile __pdata __at (0xe608) uint8_t		UART230 ;
volatile __pdata __at (0xe609) uint8_t		FIFOPINPOLAR ;
volatile __pdata __at (0xe60a) uint8_t		REVID ;
volatile __pdata __at (0xe60b) uint8_t		REVCTL ;

/* UDMA */
volatile __pdata __at (0xe60c) uint8_t		GPIFHOLDTIME ;

/* ENDPOINT CONFIGURATION */
volatile __pdata __at (0xe610) uint8_t		EP1OUTCFG ;
volatile __pdata __at (0xe611) uint8_t		EP1INCFG ;
volatile __pdata __at (0xe612) uint8_t		EP2CFG ;
volatile __pdata __at (0xe613) uint8_t		EP4CFG ;
volatile __pdata __at (0xe614) uint8_t		EP6CFG ;
volatile __pdata __at (0xe615) uint8_t		EP8CFG ;
volatile __pdata __at (0xe618) uint8_t		EP2FIFOCFG ;
volatile __pdata __at (0xe619) uint8_t		EP4FIFOCFG ;
volatile __pdata __at (0xe61a) uint8_t		EP6FIFOCFG ;
volatile __pdata __at (0xe61b) uint8_t		EP8FIFOCFG ;
volatile __pdata __at (0xe620) uint8_t		EP2AUTOINLENH ;
volatile __pdata __at (0xe621) uint8_t		EP2AUTOINLENL ;
volatile __pdata __at (0xe622) uint8_t		EP4AUTOINLENH ;
volatile __pdata __at (0xe623) uint8_t		EP4AUTOINLENL ;
volatile __pdata __at (0xe624) uint8_t		EP6AUTOINLENH ;
volatile __pdata __at (0xe625) uint8_t		EP6AUTOINLENL ;
volatile __pdata __at (0xe626) uint8_t		EP8AUTOINLENH ;
volatile __pdata __at (0xe627) uint8_t		EP8AUTOINLENL ;
volatile __pdata __at (0xe630) uint8_t		EP2FIFOPFH ;
volatile __pdata __at (0xe631) uint8_t		EP2FIFOPFL ;
volatile __pdata __at (0xe632) uint8_t		EP4FIFOPFH ;
volatile __pdata __at (0xe633) uint8_t		EP4FIFOPFL ;
volatile __pdata __at (0xe634) uint8_t		EP6FIFOPFH ;
volatile __pdata __at (0xe635) uint8_t		EP6FIFOPFL ;
volatile __pdata __at (0xe636) uint8_t		EP8FIFOPFH ;
volatile __pdata __at (0xe637) uint8_t		EP8FIFOPFL ;
volatile __pdata __at (0xe640) uint8_t		EP2ISOINPKTS ;
volatile __pdata __at (0xe641) uint8_t		EP4ISOINPKTS ;
volatile __pdata __at (0xe642) uint8_t		EP6ISOINPKTS ;
volatile __pdata __at (0xe643) uint8_t		EP8ISOINPKTS ;
volatile __pdata __at (0xe648) uint8_t		INPKTEND ;
volatile __pdata __at (0xe649) uint8_t		OUTPKTEND ;

/* INTERRUPTS */
volatile __pdata __at (0xe650) uint8_t		EP2FIFOIE ;
volatile __pdata __at (0xe651) uint8_t		EP2FIFOIRQ ;
volatile __pdata __at (0xe652) uint8_t		EP4FIFOIE ;
volatile __pdata __at (0xe653) uint8_t		EP4FIFOIRQ ;
volatile __pdata __at (0xe654) uint8_t		EP6FIFOIE ;
volatile __pdata __at (0xe655) uint8_t		EP6FIFOIRQ ;
volatile __pdata __at (0xe656) uint8_t		EP8FIFOIE ;
volatile __pdata __at (0xe657) uint8_t		EP8FIFOIRQ ;
volatile __pdata __at (0xe658) uint8_t		IBNIE ;
volatile __pdata __at (0xe659) uint8_t		IBNIRQ ;
volatile __pdata __at (0xe65a) uint8_t		NAKIE ;
volatile __pdata __at (0xe65b) uint8_t		NAKIRQ ;
volatile __pdata __at (0xe65c) uint8_t		USBIE ;
volatile __pdata __at (0xe65d) uint8_t		USBIRQ ;
volatile __pdata __at (0xe65e) uint8_t		EPIE ;
volatile __pdata __at (0xe65f) uint8_t		EPIRQ ;
volatile __pdata __at (0xe660) uint8_t		GPIFIE ;
volatile __pdata __at (0xe661) uint8_t		GPIFIRQ ;
volatile __pdata __at (0xe662) uint8_t		USBERRIE ;
volatile __pdata __at (0xe663) uint8_t		USBERRIRQ ;
volatile __pdata __at (0xe664) uint8_t		ERRCNTLIM ;
volatile __pdata __at (0xe665) uint8_t		CLRERRCNT ;
volatile __pdata __at (0xe666) uint8_t		INT2IVEC ;
volatile __pdata __at (0xe667) uint8_t		INT4IVEC ;
volatile __pdata __at (0xe668) uint8_t		INTSETUP ;

/* INPUT / OUTPUT */
volatile __pdata __at (0xe670) uint8_t		PORTACFG ;
volatile __pdata __at (0xe671) uint8_t		PORTBCFG ;
volatile __pdata __at (0xe672) uint8_t		PORTCCFG ;
volatile __pdata __at (0xe678) uint8_t		I2CS ;
volatile __pdata __at (0xe679) uint8_t		I2DAT ;
volatile __pdata __at (0xe67a) uint8_t		I2CTL ;
volatile __pdata __at (0xe67b) uint8_t		XAUTODAT1 ;
volatile __pdata __at (0xe67c) uint8_t		XAUTODAT2 ;

/* UDMA CRC */
volatile __pdata __at (0xe67d) uint8_t		UDMACRCH ;
volatile __pdata __at (0xe67e) uint8_t		UDMACRCL ;
volatile __pdata __at (0xe67f) uint8_t		UDMACRCQUALIFIER ;

/* USB CONTROL */
volatile __pdata __at (0xe680) uint8_t		USBCS ;
volatile __pdata __at (0xe681) uint8_t		SUSPEND ;
volatile __pdata __at (0xe682) uint8_t		WAKEUPCS ;
volatile __pdata __at (0xe683) uint8_t		TOGCTL ;
volatile __pdata __at (0xe684) uint8_t		USBFRAMEH ;
volatile __pdata __at (0xe685) uint8_t		USBFRAMEL ;
volatile __pdata __at (0xe686) uint8_t		MICROFRAME ;
volatile __pdata __at (0xe687) uint8_t		FNADDR ;

/* ENDPOINTS */
volatile __pdata __at (0xe68a) uint8_t		EP0BCH ;
volatile __pdata __at (0xe68b) uint8_t		EP0BCL ;
volatile __pdata __at (0xe68d) uint8_t		EP1OUTBC ;
volatile __pdata __at (0xe68f) uint8_t		EP1INBC ;
volatile __pdata __at (0xe690) uint8_t		EP2BCH ;
volatile __pdata __at (0xe691) uint8_t		EP2BCL ;
volatile __pdata __at (0xe694) uint8_t		EP4BCH ;
volatile __pdata __at (0xe695) uint8_t		EP4BCL ;
volatile __pdata __at (0xe698) uint8_t		EP6BCH ;
volatile __pdata __at (0xe699) uint8_t		EP6BCL ;
volatile __pdata __at (0xe69c) uint8_t		EP8BCH ;
volatile __pdata __at (0xe69d) uint8_t		EP8BCL ;
volatile __pdata __at (0xe6a0) uint8_t		EP0CS ;
volatile __pdata __at (0xe6a1) uint8_t		EP1OUTCS ;
volatile __pdata __at (0xe6a2) uint8_t		EP1INCS ;
volatile __pdata __at (0xe6a3) uint8_t		EP2CS ;
volatile __pdata __at (0xe6a4) uint8_t		EP4CS ;
volatile __pdata __at (0xe6a5) uint8_t		EP6CS ;
volatile __pdata __at (0xe6a6) uint8_t		EP8CS ;
volatile __pdata __at (0xe6a7) uint8_t		EP2FIFOFLGS ;
volatile __pdata __at (0xe6a8) uint8_t		EP4FIFOFLGS ;
volatile __pdata __at (0xe6a9) uint8_t		EP6FIFOFLGS ;
volatile __pdata __at (0xe6aa) uint8_t		EP8FIFOFLGS ;
volatile __pdata __at (0xe6ab) uint8_t		EP2FIFOBCH ;
volatile __pdata __at (0xe6ac) uint8_t		EP2FIFOBCL ;
volatile __pdata __at (0xe6ad) uint8_t		EP4FIFOBCH ;
volatile __pdata __at (0xe6ae) uint8_t		EP4FIFOBCL ;
volatile __pdata __at (0xe6af) uint8_t		EP6FIFOBCH ;
volatile __pdata __at (0xe6b0) uint8_t		EP6FIFOBCL ;
volatile __pdata __at (0xe6b1) uint8_t		EP8FIFOBCH ;
volatile __pdata __at (0xe6b2) uint8_t		EP8FIFOBCL ;
volatile __pdata __at (0xe6b3) uint8_t		SUDPTRH ;
volatile __pdata __at (0xe6b4) uint8_t		SUDPTRL ;
volatile __pdata __at (0xe6b5) uint8_t		SUDPTRCTL ;
volatile __pdata __at (0xe6b8) uint8_t		SETUPDAT[8] ;

/* GPIF */
volatile __pdata __at (0xe6c0) uint8_t		GPIFWFSELECT ;
volatile __pdata __at (0xe6c1) uint8_t		GPIFIDLECS ;
volatile __pdata __at (0xe6c2) uint8_t		GPIFIDLECTL ;
volatile __pdata __at (0xe6c3) uint8_t		GPIFCTLCFG ;
volatile __pdata __at (0xe6c4) uint8_t		GPIFADRH ;
volatile __pdata __at (0xe6c5) uint8_t		GPIFADRL ;

/* FLOWSTATE */
volatile __pdata __at (0xe6c6) uint8_t		FLOWSTATE ;
volatile __pdata __at (0xe6c7) uint8_t		FLOWLOGIC ;
volatile __pdata __at (0xe6c8) uint8_t		FLOWEQ0CTL ;
volatile __pdata __at (0xe6c9) uint8_t		FLOWEQ1CTL ;
volatile __pdata __at (0xe6ca) uint8_t		FLOWHOLDOFF ;
volatile __pdata __at (0xe6cb) uint8_t		FLOWSTB ;
volatile __pdata __at (0xe6cc) uint8_t		FLOWSTBEDGE ;
volatile __pdata __at (0xe6cd) uint8_t		FLOWSTBPERIOD ;
volatile __pdata __at (0xe6ce) uint8_t		GPIFTCB3 ;
volatile __pdata __at (0xe6cf) uint8_t		GPIFTCB2 ;
volatile __pdata __at (0xe6d0) uint8_t		GPIFTCB1 ;
volatile __pdata __at (0xe6d1) uint8_t		GPIFTCB0 ;
volatile __pdata __at (0xe6d2) uint8_t		EP2GPIFFLGSEL ;
volatile __pdata __at (0xe6d3) uint8_t		EP2GPIFPFSTOP ;
volatile __pdata __at (0xe6d4) uint8_t		EP2GPIFTRIG ;
volatile __pdata __at (0xe6da) uint8_t		EP4GPIFFLGSEL ;
volatile __pdata __at (0xe6db) uint8_t		EP4GPIFPFSTOP ;
volatile __pdata __at (0xe6dc) uint8_t		EP4GPIFTRIG ;
volatile __pdata __at (0xe6e2) uint8_t		EP6GPIFFLGSEL ;
volatile __pdata __at (0xe6e3) uint8_t		EP6GPIFPFSTOP ;
volatile __pdata __at (0xe6e4) uint8_t		EP6GPIFTRIG ;
volatile __pdata __at (0xe6ea) uint8_t		EP8GPIFFLGSEL ;
volatile __pdata __at (0xe6eb) uint8_t		EP8GPIFPFSTOP ;
volatile __pdata __at (0xe6ec) uint8_t		EP8GPIFTRIG ;
volatile __pdata __at (0xe6f0) uint8_t		XGPIFSGLDATH ;
volatile __pdata __at (0xe6f1) uint8_t		XGPIFSGLDATLX ;
volatile __pdata __at (0xe6f2) uint8_t		XGPIFSGLDATLNOX ;
volatile __pdata __at (0xe6f3) uint8_t		GPIFREADYCFG ;
volatile __pdata __at (0xe6f4) uint8_t		GPIFREADYSTAT ;
volatile __pdata __at (0xe6f5) uint8_t		GPIFABORT ;

/* ENDPOINT BUFFERS */
volatile __xdata __at (0xe740) uint8_t		EP0BUF[64] ;
volatile __xdata __at (0xe780) uint8_t		EP1OUTBUF[64] ;
volatile __xdata __at (0xe7c0) uint8_t		EP1INBUF[64] ;
volatile __xdata __at (0xf000) uint8_t		EP2FIFOBUF[1024] ;
volatile __xdata __at (0xf400) uint8_t		EP4FIFOBUF[512] ;
volatile __xdata __at (0xf800) uint8_t		EP6FIFOBUF[1024] ;
volatile __xdata __at (0xfc00) uint8_t		EP8FIFOBUF[512] ;


#endif/*__EZUSB_FX2__REGS_H__INCLUDED__*/
