/* ================================================================================ */
/*   ezusb_fx2/spi.c                                                                */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"


static __NEAR uint8_t				m_mode ;						/* SPI [h */


/* -------------------------------------------------------------------------------- */
/*   [hݒ                                                                     */
/*                                                                                  */
/*   IN : mode = [h                                                             */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void spi_mode( uint8_t mode ) __naked
{
	mode = mode ;

	__asm__(
	"IOA		=	_IOA								\n"
	"	IOA_0	=	_IOA_0								\n"
	"	IOA_1	=	_IOA_1								\n"
	"	IOA_2	=	_IOA_2								\n"
	"	IOA_3	=	_IOA_3								\n"
	"	IOA_4	=	_IOA_4								\n"
	"	IOA_5	=	_IOA_5								\n"
	"	IOA_6	=	_IOA_6								\n"
	"	IOA_7	=	_IOA_7								\n"
	"IOB		=	_IOB								\n"
	"	IOB_0	=	_IOB_0								\n"
	"	IOB_1	=	_IOB_1								\n"
	"	IOB_2	=	_IOB_2								\n"
	"	IOB_3	=	_IOB_3								\n"
	"	IOB_4	=	_IOB_4								\n"
	"	IOB_5	=	_IOB_5								\n"
	"	IOB_6	=	_IOB_6								\n"
	"	IOB_7	=	_IOB_7								\n"
	"IOC		=	_IOC								\n"
	"	IOC_0	=	_IOC_0								\n"
	"	IOC_1	=	_IOC_1								\n"
	"	IOC_2	=	_IOC_2								\n"
	"	IOC_3	=	_IOC_3								\n"
	"	IOC_4	=	_IOC_4								\n"
	"	IOC_5	=	_IOC_5								\n"
	"	IOC_6	=	_IOC_6								\n"
	"	IOC_7	=	_IOC_7								\n"
	"IOD		=	_IOD								\n"
	"	IOD_0	=	_IOD_0								\n"
	"	IOD_1	=	_IOD_1								\n"
	"	IOD_2	=	_IOD_2								\n"
	"	IOD_3	=	_IOD_3								\n"
	"	IOD_4	=	_IOD_4								\n"
	"	IOD_5	=	_IOD_5								\n"
	"	IOD_6	=	_IOD_6								\n"
	"	IOD_7	=	_IOD_7								\n"
	"SCLK		=	" SPI_SCLK                         "\n"
	"MOSI		=	" SPI_MOSI                         "\n"
	"MISO		=	" SPI_MISO                         "\n"
	"													\n"
	"													\n"
	"	MOV		A, DPL									\n"
	"	MOV		_m_mode, A								\n"
	"													\n"
	"	JB		ACC.3, _spi_mode_180					\n"
	"													\n"
	"_spi_mode_100:										\n"
	"	CLR		SCLK									\n"
	"	SETB	MOSI									\n"
	"	RET												\n"
	"													\n"
	"_spi_mode_180:										\n"
	"	SETB	SCLK									\n"
	"	SETB	MOSI									\n"
	"	RET												\n"
	) ;
}

/* -------------------------------------------------------------------------------- */
/*   Wrbg]                                                                   */
/*                                                                                  */
/*   IN : sendData = Mf[^                                                     */
/*   OUT: Mf[^                                                                */
/* -------------------------------------------------------------------------------- */
uint8_t spi_xfer8( uint8_t sendData ) __naked
{
	sendData = sendData ;

	__asm__(
	"	MOV		R0, DPL									\n"
	"	MOV		R1, #8									\n"
	"	MOV		DPTR, #spi_xfer_jmptbl					\n"
	"	MOV		A, _m_mode								\n"
	"	JMP		@A+DPTR									\n"
	"													\n"
	"spi_xfer_jmptbl:									\n"
	"	CLR		SCLK					; [h 0		\n"
	"	SJMP	spi_xfer_mode02							\n"
	"	CLR		SCLK					; [h 1		\n"
	"	SJMP	spi_xfer_mode13							\n"
	"	SETB	SCLK					; [h 2		\n"
	"	SJMP	spi_xfer_mode02							\n"
	"	SETB	SCLK					; [h 3		\n"
	"	SJMP	spi_xfer_mode13							\n"
	"													\n"
	"; ------------------------------------------------ \n"
	";   [h 0/2                                     \n"
	"; ------------------------------------------------ \n"
	"spi_xfer_mode02:									\n"
	"	MOV		A, R0									\n"
	"	RLC		A										\n"
	"	SJMP	spi_xfer_mode02_140						\n"
	"													\n"
	"spi_xfer_mode02_100:								\n"
	"	CPL		SCLK					; 2				\n"
	"spi_xfer_mode02_140:								\n"
	"	MOV		MOSI, C					; 2				\n"
	"	MOV		C, MISO					; 2				\n"		/* SCLK XVOɓǂݍővȂ͂ */
	"	CPL		SCLK					; 2				\n"
	"	RLC		A						; 1				\n"
	"	DJNZ	R1, spi_xfer_mode02_100	; 3				\n"
	"													\n"
	"	CPL		SCLK									\n"
	"	MOV		DPL, A									\n"
	"	RET												\n"
	"													\n"
	"; ------------------------------------------------ \n"
	";   [h 1/3                                     \n"
	"; ------------------------------------------------ \n"
	"spi_xfer_mode13:									\n"
	"	MOV		A, R0									\n"
	"	RLC		A										\n"
	"spi_xfer_mode13_100:								\n"
	"	CPL		SCLK					; 2				\n"
	"	MOV		MOSI, C					; 2				\n"
	"	MOV		C, MISO					; 2				\n"		/* SCLK XVOɓǂݍővȂ͂ */
	"	CPL		SCLK					; 2				\n"
	"	RLC		A						; 1				\n"
	"	DJNZ	R1, spi_xfer_mode13_100	; 3				\n"
	"	MOV		DPL, A									\n"
	"	RET												\n"
	) ;
}
