/* ================================================================================ */
/*   driver/uart.c                                                                  */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#include "rtos.h"
#include "uart.h"


	enum {
		SENDBUFF_MASK				=	UART_SENDBUFF_SIZE - 1,		/* Mobt@}XN */
		RECVBUFF_MASK				=	UART_RECVBUFF_SIZE - 1		/* Mobt@}XN */
	} ;


static __FAR  uint8_t				m_sendBuff[UART_SENDBUFF_SIZE] ;/* Mobt@             */
static __FAR  uint8_t				m_recvBuff[UART_RECVBUFF_SIZE] ;/* Mobt@             */
static __NEAR uint8_t				m_sendBuffRead ;				/* Mobt@ǂݎʒu */
static __NEAR uint8_t				m_sendBuffWrite ;				/* Mobt@݈ʒu */
static __NEAR uint8_t				m_recvBuffRead ;				/* Mobt@ǂݎʒu */
static __NEAR uint8_t				m_recvWritePos ;				/* Mobt@݈ʒu */


/* -------------------------------------------------------------------------------- */
/*                                                                            */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void  uart_init( void )
{
	ES   = 0 ;
	TR1  = 0 ;

	/* ^C}[P */
	TMOD = (TMOD & 0x0f) | T1_M1 ;
	TH1  = UART_COUNTER ;
	TL1  = UART_COUNTER ;

	/* VA */
	PCON |= SMOD ;
	SCON  = 0x50 ;

	TR1  = 1 ;
	ES   = 1 ;
}


/* -------------------------------------------------------------------------------- */
/*   PoCgǂݎ                                                               */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: f[^                                                                    */
/* -------------------------------------------------------------------------------- */
uint8_t uart_read( void )
{
	uint8_t		readData ;


	wai_sem( UART_RX_SEMID ) ;

	loc_cpu() ;

	readData = m_recvBuff[m_recvBuffRead&RECVBUFF_MASK] ;
	m_recvBuffRead++ ;

	unl_cpu() ;

	return readData ;
}


/* -------------------------------------------------------------------------------- */
/*   PoCg                                                               */
/*                                                                                  */
/*   IN : writeData = f[^                                                        */
/*   OUT:                                                                       */
/* -------------------------------------------------------------------------------- */
void uart_write( uint8_t writeData )
{
	wai_sem( UART_TX_SEMID ) ;

	loc_cpu() ;

	if( m_sendBuffWrite == m_sendBuffRead ) {
		SBUF = writeData ;
	} else {
		m_sendBuff[m_sendBuffWrite&SENDBUFF_MASK] = writeData ;
	}
	m_sendBuffWrite++ ;

	unl_cpu() ;
}


/* -------------------------------------------------------------------------------- */
/*   荞݃T[rX[`                                                       */
/*                                                                                  */
/*   IN : Ȃ                                                                      */
/*   OUT: Ȃ                                                                      */
/* -------------------------------------------------------------------------------- */
void uart_isr( void ) INTPROC
{
	/* M */
	if( RI ) {
		m_recvBuff[m_recvWritePos++&RECVBUFF_MASK] = SBUF ;

		RI = 0 ;

		if( isig_sem( UART_RX_SEMID ) != E_OK ) {
			m_recvBuffRead++ ;
		}
	}

	/* M */
	if( TI ) {
		TI = 0 ;

		if( ++m_sendBuffRead != m_sendBuffWrite ) {
			SBUF = m_sendBuff[m_sendBuffRead&SENDBUFF_MASK] ;
		}

		isig_sem( UART_TX_SEMID ) ;
	}
}
