/* ================================================================================ */
/*   mw/fat.h                                                                       */
/*                                                                                  */
/*   Copyright (C) 2014 lsluk, All rights reserved.                                 */
/*   http://www.geocities.jp/g_lsluk/index.html                                     */
/* ================================================================================ */
#ifndef __MW__FAT_H__INCLUDED__
#define __MW__FAT_H__INCLUDED__

	/* t@C */
	enum {
		ATTR_READ_ONLY				=	0x01,						/* ǂݎp       */
		ATTR_HIDDEN					=	0x02,						/* B               */
		ATTR_SYSTEM					=	0x04,						/* VXe           */
		ATTR_VOLUME_ID				=	0x08,						/* {[x   */
		ATTR_DIRECTORY				=	0x10,						/* fBNg       */
		ATTR_ARCHIVE				=	0x20,						/* A[JCu         */
																	/* Ol[       */
		ATTR_LONG_NAME				=	ATTR_READ_ONLY|ATTR_HIDDEN|ATTR_SYSTEM|ATTR_VOLUME_ID,
																	/* Ol[}XN */
		ATTR_LONG_NAME_MASK			=	ATTR_READ_ONLY|ATTR_HIDDEN|ATTR_SYSTEM|ATTR_VOLUME_ID|ATTR_DIRECTORY|ATTR_ARCHIVE
	} ;

	/* u[gZN^iFAT12/16j */
	typedef struct {
		uint8_t						BS_DrvNum ;						/* hCuԍ                 */
		uint8_t						BS_Reserved1 ;					/* \                         */
		uint8_t						BS_BootSig ;					/* u[gVOl`             */
		uint8_t						BS_VolID[4] ;					/* {[VAԍ       */
		uint8_t						BS_VolLab[11] ;					/* {[x             */
		uint8_t						BS_FilSysType[8] ;				/* t@CVXe^Cv       */
	} BOOTSECTOR12, BOOTSECTOR16 ;

	/* u[gZN^iFAT32j */
	typedef struct {
		uint8_t						BPB_FATSz32[4] ;				/* FAT                                */
		uint8_t						BPB_ExtFlags[2] ;				/* gtO                           */
		uint8_t						BPB_FSVer[2] ;					/* t@CVXeo[W           */
		uint8_t						BPB_RootClus[4] ;				/* [gfBNg擪NX^ԍ   */
		uint8_t						BPB_FSInfo[2] ;					/* t@CVXẽR[hԍ   */
		uint8_t						BPB_BkBootSec[2] ;				/* u[gR[hobNAbṽR[h */
		uint8_t						BPB_Reserved[12] ;				/* \                                 */
		uint8_t						BS_DrvNum ;						/* hCuԍ                         */
		uint8_t						BS_Reserved1 ;					/* \                                 */
		uint8_t						BS_BootSig ;					/* u[gVOl`                     */
		uint8_t						BS_VolID[4] ;					/* {[VAԍ               */
		uint8_t						BS_VolLab[11] ;					/* {[x                     */
		uint8_t						BS_FilSysType[8] ;				/* t@CVXe^Cv               */
	} BOOTSECTOR32 ;

	/* p[eBVu[gR[h */
	typedef struct {
		uint8_t						BS_jmpBoot[3] ;					/* Wv߁{NOP            */
		uint8_t						BS_OEMName[8] ;					/* [Jуo[W     */
		uint8_t						BPB_BytsPerSec[2] ;				/* PZN^̃oCg     */
		uint8_t						BPB_SecPerClus ;				/* PNX^̃ZN^   */
		uint8_t						BPB_RsvdSecCnt[2] ;				/* FAT JnZN^ԍ           */
		uint8_t						BPB_NumFATs ;					/* FAT                        */
		uint8_t						BPB_RootEntCnt[2] ;				/* [gfBNgGg */
		uint8_t						BPB_TotSec16[2] ;				/* ZN^i16bitj          */
		uint8_t						BPB_Media ;						/* fBAfBXNv^       */
		uint8_t						BPB_FATSz16[2] ;				/* FAT ZN^iFAT12/16j     */
		uint8_t						BPB_SecPerTrk[2] ;				/* gbÑZN^     */
		uint8_t						BPB_NumHeads[2] ;				/* wbh                     */
		uint8_t						BPB_HiddSec[4] ;				/* BZN^                 */
		uint8_t						BPB_TotSec32[4] ;				/* ZN^i32bitj          */
		union {
			BOOTSECTOR12			fat12 ;							/* FAT12                        */
			BOOTSECTOR16			fat16 ;							/* FAT16                        */
			BOOTSECTOR32			fat32 ;							/* FAT32                        */
		} BS ;
		uint8_t						BS_BootCode[420] ;				/* u[gR[h                 */
		uint8_t						BS_Signature[2] ;				/* VOl`i0x55aaj         */
	} PBR ;

	/* t@CVXe */
	typedef struct {
		uint8_t						FSI_LeadSig[4] ;				/* 擪VOl`           */
		uint8_t						FSI_Reserved1[480] ;			/* \                     */
		uint8_t						FSI_StrucSig[4] ;				/* VOl`               */
		uint8_t						FSI_Free_Count[4] ;				/* 󂫃NX^           */
		uint8_t						FSI_Nxt_Free[4] ;				/* ŏI݃NX^ԍ */
		uint8_t						FSI_Reserved2[12] ;				/* \                     */
		uint8_t						FSI_TrailSig[4] ;				/* ŌVOl`           */
	} FSINFO ;

	/* fBNgGg */
	typedef struct {
		uint8_t						DIR_Name[11] ;					/* t@C                 */
		uint8_t						DIR_Attr ;						/* iATTR_xxxxj          */
		uint8_t						DIR_NTRes ;						/* NT tO                  */
		uint8_t						DIR_CrtTimeTenth ;				/* 쐬ԁi1/100 bj       */
		uint8_t						DIR_CrtTime[2] ;				/* 쐬                   */
		uint8_t						DIR_CrtDate[2] ;				/* 쐬t                   */
		uint8_t						DIR_LstAccDate[2] ;				/* ANZXt               */
		uint8_t						DIR_FstClusHI[2] ;				/* JnNX^i 16bitj */
		uint8_t						DIR_WrtTime[2] ;				/* XV                   */
		uint8_t						DIR_WrtDate[2] ;				/* XVt                   */
		uint8_t						DIR_FstClusLO[2] ;				/* JnNX^i 16bitj */
		uint8_t						DIR_FileSize[4] ;				/* t@CTCY             */
	} DIRENTRY ;


#endif/*__MW__FAT_H__INCLUDED__*/
